%
% programma dimostrativo su alcuni comandi "uicontrol"
%			file: pr	 (programma principale)		26/10/1997
%
% Il programma mostra l'utilizzo di alcuni bottoni: 
% quelli a tendina  a testo editabile e a bottoni da premere. 
%
%
% le seguenti 5 righe permettono di impostare una finestra grafica:
% riga 1: definisce la figura 1 con "maniglia" <a>;
% riga 2: assegna alla figura <a> l'attributo unita' e 
%			quello della posizione.  Riguardo a quest'ultimo
%			si ricorda [x_a_sinistra y_in _basso larghezza altezza]
%			con le dimensioni dello schermo pari a 1
%			per cui lo per lo schermo pieno [0 0 1 1];
% riga 3: posizione degli assi sulla figura;
% riga 4: valori minimi e massimi degli assi.
%			Rispettivamente [xmin xmax ymin ymax];
% riga 5: inibizione del refresh del grafico e 
%			conseguente blocco delle scale.
%
	a=figure(1);
	set(a,'Units','normalized','Position',[0 0 1 0.90]);
	h=axes('position',[0.1 0.1 0.70 0.70]);
	axis([0 100 0 80]);
	hold on;
%
% comandi "uicontrol"
%
% sono state definite solo alcune delle propriet del comando:
% - "style" che specifica il tipo di input;
% - "position" che stabilisce la collocazione e 
%		la dimensione [da_sinistra dal_basso larghezza altezza];
% - "string" che restituisce una scritta;
% - "callback" che chiama un programma.
%
% entrando nel dettaglio:
% i primi due (e1, e2) creano delle caselle in cui si possono
%		inserire da tastiera dei valori: sono definiti "editable text";
% il terzo (p1) crea un menu' a tendina a piu' elementi tipo "popup";
% il quarto e quinto (t1, t2) permettono di porre delle stringhe
%		in una parte dello schermo: "static text";
% il sesto (b1) disegna un bottone ("push button") cliccando il quale 
%		si chiude la finestra grafica.
%
	v=350; 
	% testi editabili: in pratica si puo' scrivere dentro
	e1=uicontrol('style','edit',...
   	'position',[20 v 50 25],'callback','pr1','Units','pixel');
	e2=uicontrol('style','edit',...
   	'position',[160 v 50 25],'callback','pr2','Units','pixel');
	% a tendina ("pop up")
	p1=uicontrol('style','popup','string','triangolo|rettangolo',...
   	'position',[260 (v-25) 100 50],'callback','pr3','Units','pixel');
	% scritte
	t1=uicontrol('style','text','string','base',...
   	'position',[20 (v+25) 40 20]);
	t2=uicontrol('style','text','string','altezza',...
   	'position',[160 (v+25) 40 20],'Units','pixel');
	% bottone ds premere
	b1=uicontrol('style','pushbutton','string','fine',...
   	'position',[390,v, 50 25],'callback','pr4','Units','pixel');
	
	
