%  -----------------------------------------------------------------
%      				   naturale_altri
%     Integrazione dell'equazione dei moti armonici
%         con il metodo naturale e con altri
% 	richiama: f_armonico
%  -----------------------------------------------------------------
	clear all
  	close all ;    clc
 	global  A  c  k  m	  
%	scelta	
	Eulero=0; 				% 0 1
	Eulero_Cauchy=0; 		% 0 1
	Runge_Kutta_II=0; 	% 0 1
	Runge_Kutta_IV=1; 	% 0 1
	Celle=1; 				% 0 1
%
%  moto armonico smorzato con x(0)=0
%	x(t) = A*exp(-D*t)*sin(w*t); 
%	v(t) = -D*A*exp(-D*t)* sin(w*t)+A*w*exp(-D*t)*cos(w*t); 
%	v(0) = A*w;  
%
%  ------------------ GRAFICA ----------------------------
 	h1 = figure(1);
%  set(h1, 'Units', 'normalized', 'Position', [0 0 1 0.93]);
	set(h1, 'Units', 'normalized', 'Position', [0.5 0.5 0.5 0.5]);
	whitebg(h1, 'k')
   axis([0 7 -20 20]);  %   (xmin xmax ymin ymax] 		 
   title('confronto Celle-altri');
%  scrivi sugli assi 
  	xlabel('tempo'); ylabel('elongazione')
%   colore degli assi ( gca = g-et c-urrent a-xis handle)  
	set (gca,'XColor','w', 'YColor','w' )
	hold on ; zoom on; grid on
%  -------------------- DATI ----------------------------------
	m = 1;				% 	massa 
    k = 40;				%	rigidezza
	c = 0.0;				% 	coefficiente di smorzamento
	D = c/(2*m);
    A = 10; 				%	ampiezza
    w = sqrt(k/m-D*D);      %	pulsazione

	Tfin = 7;			% intervallo [0,Tfin]
	h = 0.05;   		    % <------------$$$$$$$$$$$
	T = 0 : h : Tfin;   % vettore dei tempi
	N = size(T,2);   	% numero di elementi    
%  -----------------------------------------------------------------
%  traccia soluzione esatta in bianco
	p = 0.001;  %   passo per il tracciamento
%  crea un vettore "TT" da "0" a "7" a passo "p"		
	TT = 0 : p : Tfin ;  
   Z = A * exp(-D*TT) .* sin(w*TT); 
 	plot (TT, Z,'w');
%	
if Eulero==1 
%  -----------------------------------------------------------------
%   soluzione col metodo di Eulero (in rosso)
%  -----------------------------------------------------------------
%	costruisci i vettori Y e P	
 	Y(1) = 0;			%   posizione iniziale
	P(1) = m*A*w;  	%   quantit di moto iniziale	
	for i = 1 : N-1
 		[Dy,Dp] = f_armonico (h, T(i), Y(i), P(i)); 
   	Y(i+1) = Y(i) + Dy;
 		P(i+1)  = P(i) + Dp; 
	end
  	plot(T,Y,'r:') 
end
%
if Runge_Kutta_II==1 
%  -----------------------------------------------------------------
%  		Runge-Kutta II (punto in rosso)
%  -----------------------------------------------------------------
%  valuta la derivata all'inizio e alla fine quindi prende la media ???
%  x'(t)=p/m 				x(t+h)=x(t)+ (p(t)/m)*h	
%	p'(t)= k*x+c p/m		p(t+h)=p(t)-(k*x(t)+c*p/m)*h
%
%  							x(t+h)=x(t)+[p(t)/m+p(t+h)/m]/2*h	
%							p(t+h)=p(t)+[-k*x(t)-k*x(t+h)]/2*h

%   costruisci i vettori Y e PR
   X(1) = 0;			%  posizione iniziale
  	P(1) = m*A*w;  	%  quantit di moto iniziale
  	for j = 1 : N-1
%		incremento con la derivata nel punto iniziale
 		[Dx1,Dp1] = f_armonico (h, T(j), X(j), P(j));
%		incremento con la derivata nel punto medio
 		[Dx2,Dp2] = f_armonico (h, T(j)+h, X(j)+Dx1, P(j)+Dp1);
%	 	media	
    	Dx  = (Dx1+Dx2)/2;
  		Dp  = (Dp1+Dp2)/2;
   	X(j+1) = X(j) + Dx;
   	P(j+1) = P(j) + Dp; 
   end
    plot(T,X,'r.')
end
%
if Eulero_Cauchy==1 
%  -----------------------------------------------------------------
%  		 Heun = Eulero-Cauchy (in verde)
%  -----------------------------------------------------------------
%  valuta la derivata all'inizio e alla fine quindi prende la media
% 	Abramowitz 896
%   x'(t)=p/m 		x(t+h)=x(t)+ (p(t)/m)*h	
%	p'(t)=-k*x		p(t+h)=p(t)+(-k*x(t))*h
%  					x(t+h) =x(t)+[p(t)/m+p(t+h)/m]/2*h	
%					p(t+h)=p(t)+[-k*x(t)-k*x(t+h)]/2*h
% 
%   costruisci i vettori Y e PR
   X(1) = 0;			%  posizione iniziale
  	P(1) = m*A*w;  	%  quantit di moto iniziale
  	for j = 1 : N-1
%		incremento con la derivata nel punto iniziale
 		[Dx1,Dp1] = f_armonico (h, T(j), X(j), P(j));
%		incremento con la derivata nel punto medio
 		[Dx2,Dp2] = f_armonico (h, T(j)+h/2, X(j)+Dx1/2, P(j)+Dp1/2);
%	 		
   	X(j+1) = X(j) + Dx2;  % errato <<<<<<<<<
   	P(j+1) = P(j) + Dp2; 
    end
    plot(T,X,'g.')
end
 %
if Runge_Kutta_IV==1
%  -----------------------------------------------------------------
% 	metodo di Runge-Kutta quarto ordine (croce in bianco)  
%  -----------------------------------------------------------------
%  Dx1 = h f(T(n), X(n)) 
%  Dx2 = h f(T(n)+h /2, X(n)+Dx1 /2)
%  Dx3 = h f(T(n)+h /2, X(n)+Dx2 /2)  
%  Dx4 = h f(T(n)+h,  X(n)+Dx3)
%  X(n+1)=X(n)+(Dx1+2*Dx2+2* Dx3+Dx4)/6
%	e analoghe per la P
   X(1) = 0;			%  posizione iniziale
 	P(1) = m*A*w;  	%  quantit di moto iniziale
	E(1) = X(1);		%	esatto
	ermax = 0;

 	for n = 1 : N-1
%		incremento con la derivata nel punto INIZIALE
 		[Dx1,Dp1] = f_armonico (h, T(n), X(n), P(n));
%		incremento con la derivata nel punto medio
  		[Dx2,Dp2] = f_armonico (h, T(n)+h/2, X(n)+Dx1/2, P(n)+Dp1/2);
%		incremento con la derivata nel punto medio
  		[Dx3,Dp3] = f_armonico (h, T(n)+h/2, X(n)+Dx2/2, P(n)+Dp2/2);
%		incremento con la derivata nel punto FINALE
  		[Dx4,Dp4] = f_armonico (h, T(n)+h, X(n)+Dx3, P(n)+Dp3);
%		media pesata degli incrementi
   	Dx  = (Dx1+2*Dx2+2*Dx3+Dx4)/6;
		Dp  = (Dp1+2*Dp2+2*Dp3+Dp4)/6	;
  		X(n+1) = X(n) + Dx;
		P(n+1)  = P(n) + Dp; 
		E(n+1) = A * exp(-D*T(n+1)) * sin(w*T(n+1));		%	esatto
%		valuta l'errore massimo
		scarto = abs(X(n+1)-E(n+1));
		if scarto > ermax    
	 		 ermax = scarto; 
		end
	end
   plot(T,X,'r+')
end
%
if Celle==1
%  -----------------------------------------------------------------
%			Celle  (croce in giallo)
%  -----------------------------------------------------------------
%	s 	= 1 + c*h/(2*m);
%	ss	= 1 - c*h/(2*m);
% 
%	t(n) = t(n-1)+h
%	x(n) = x(n-1) + h /m*  p(nn)  
% 	p(n + 1) = ( p(n) *ss   - h*k* x(n) ) /s
% 	dal momento che MATLAB numera le componenti da uno anziche' da zero
% 	aumentiamo l'indice di uno:
%	T(n+1) = T(n)   + h
%	X(n+1) = X(n)   + h / m * P(n+1)   
%	P(n+2) = ( P(n+1)*ss - h*k*X(n+1) ) /s
%--------	
 	s =1+c*h /(2*m);
	ss=1-c*h /(2*m);
 	X(1) = 0;			%   posizione iniziale
 	P(2) = m*A*w;  	%   quantit di moto iniziale
	Emax=0;
%
 beta=2/sqrt(3)
 
	for n = 1 : N-1
		Xe(n)= A * exp(-D*T(n))*sin(w*T(n));%  soluzione esatta  
		err=abs(Xe(n)-X(n));
		if err>Emax 
			Emax=err;
		end
		
		T(n+1)=T(n)+h;		
 		X(n+1) = X(n) + (h / m)*beta*P(n+1);
		P(n+2)= (P(n+1)*ss - h*k*X(n+1)) /s;
		beta=abs(1-beta)

%
% modifica per applicare l'algoritmo di Romberg
% 16/4/2000
% zovatto luigino
%

%  	s =1+c*h /(2*m);
% 	ss=1-c*h /(2*m);
% 	
% 		T1=T(n)+h;		
%  		X1= X(n) + h / m * P(n+1);
%  		P1= (P(n+1)*ss - h*k*X1) /s;
% 
%  	    s =1+c*(h/2) /(2*m);
% 	    ss=1-c*(h/2) /(2*m);
% 	
% 		T2=T(n)+h/2;		
%  		X2= X(n) + (h/2) / m * P(n+1);
%  		P2= (P(n+1)*ss - (h/2)*k*X2) /s;
% 		
% 		T2=T2+h/2;		
%  		X2= X2 + (h/2) / m * P2;
%  		P2= (P2*ss - (h/2)*k*X2) /s;
% 	    beta=10/9;
% % valore medio ipotizzando il metodo delle celle con ordine III ordine 
% 		beta=4/3;
% % valore medio ipotizzando il metodo delle celle con ordine II ordine 
% 		beta=1.24;
% % valore ottimo
%         beta=10/9;
% % valore medio ipotizzando il metodo delle celle con ordine tra III ordine e II ordine
% 		X(n+1)=X1*(1-beta)+X2*(beta);
% 		P(n+2)=P1*(1-beta)+P2*(beta);
% 		T(n+1)=T2;

	end
	
     plot(T,X,'y+')
     beta=1.0	
	fprintf('h=%8.6f     Emax=%12.10f  beta=%8.4f\n',h,Emax,beta);
end
	




