%	==============================================================

%      			RungeKutta1.m

%   Integrazione equazione differenziale  

%			x'(t)= f( t, x(t) )

%   con il metodo di Runge-Kutta del 4Infinity ordine.

%  chiama "f_nome"

%-------------------------------------------------------

 	clear 	% azzera le variabili in memoria

	clc		% pulisci finestra di testo

	close		

	global h 	% fa sentire la variabile "p" alle funzioni chiamate

%	-------------------------------------------------------------- 

%		 seleziona modalita' grafica 

%	-------------------------------------------------------------- 

% 	apre una finestra grafica di dimensioni volute

	h1 = figure(1); 	

	set(h1, 'Units', 'normalized', 'Position', [0 0.5 0.45 0.5]);

%	set(h1, 'Units', 'normalized', 'Position', [0 0  1  0.96]);

% 	colore di fondo

  	whitebg(h1, 'black')

%	assi di dimensioni volute

	axis([0 20 -1.2 1.2] );  % [xmin xmax ymin ymax]

%	"hold on" consente piu' tracciamenti sulla stessa finestra

	hold on ; zoom on

%	-------------------------------------------------------------- 

%					scritte

%	-------------------------------------------------------------- 

 	h3=title('integrazione col metodo di Runge-Kutta IV ordine');

 	set(h3,'fontsize',14,'color','yellow','fontname','times');

	xlabel('t');  ylabel('y');

%	-------------------------------------------------------------- 

% 			soluzione esatta  x=sin(t)

%	-------------------------------------------------------------- 			

	t0 = 0;			% ascissa iniziale

	x0 = 1;  			% ordinata iniziale

	tf = 20;	 		% istante finale

	p = 0.1;  			% intervallo temporale per l'integrazione

%	grafico soluzione esatta

	T = 0 : p : tf;		% crea array dei tempi

	X =exp(-T);	% crea array delle posizioni

	plot(T,X,'c')

	pause

%	--------------------------------------------------- 

% 			soluzione approssimata   		

%	--------------------------------------------------- 

	n =100;		% passi d'integrazione

	h = tf / n;		% passo temporale

	t(1) = t0;		% istante iniziale

	x(1) = x0;	% posizione iniziale

%	

 	for i=1:n

		[k1] = f_nome(t(i), x(i)) ;

 		[k2] = f_nome(t(i)+h/2, x(i)+k1/2) ;

 		[k3] = f_nome(t(i)+h/2, x(i)+k2/2) ;

 		[k4] = f_nome(t(i)+h,  x(i)+k3) ;

		K = (k1+2*k2+2*k3+k4) / 6;  % media pesata

		t(i+1)=t(i)+h;		

		x(i+1)=x(i)+K;	

	end

	plot(t,x,'y')

%	================================================================

% 	Qui si riporta la funzione che deve essere scritta in un file a parte per essere richiamata

%	dal programma riportato sopra la linea ======

%	----------------------------------------------------------------  

%  	 	  function  k = f_nome(t, x);

%

%	global h	% fa sentire la variabile "h" dal programma chiamante

% 	richiamata da "RungeKutta1.m"  

%	per l'equazione dei x'(t)=f(x,y)

%	

%	 k = h*(-x);







 

 

