%	===========================================
%      	RungeKutta2.m
%	===========================================
%   	Integrazione equazione differenziale  x''(t)= f( t , x(t) , x'(t) )
%      con il metodo di Runge-Kutta del 4Infinity ordine.
% 			x'(t) = F ( t , x(t) , v(t) )
%			v'(t) = G( t , x(t) , v(t) )
% 	 chiama "f_armonici"
%	-------------------------------------------------------
 	clear 	% azzera le variabili in memoria
	clc		% pulisci finestra di testo
	global k  m  Dt
%	-------------------------------------------------------------- 
%		 seleziona modalita' grafiche 
%	-------------------------------------------------------------- 
% 	chiudi finestra grafica precedente	
	close		
% 	apre una finestra grafica di dimensioni volute
	h1 = figure(1); 	
	set(h1, 'Units', 'normalized', 'Position', [0.5 0.5 0.5  0.46]);
%	set(h1, 'Units', 'normalized', 'Position', [0 0  1  0.96]);
% 	colore di fondo
  	whitebg(h1, 'black')
%	assi di dimensioni volute
	axis([0 20 -1.2 1.2] );  % [xmin xmax ymin ymax]
%	"hold on" consente piu' tracciamenti sulla stessa finestra
	hold on
	zoom on
	title('integrazione col metodo di Runge-Kutta');
	xlabel('t');
	ylabel('x');
% 	soluzione esatta y=sin(t)
	t0=0;	x0=1;		v0=0;
	tf=20;
	Dt=0.1; 
	k=12; 	m=2;	
	w=sqrt(k/m);
% 	soluzione esatta
	t= t0 : Dt : tf;
	x=x0* cos(w*t);
	plot(t,x,'c')
%	------------------------------------------------------------------------
	Dt=0.1;
	t=t0;		x=x0;	v=v0;
%
 	while t<tf 
		[Dx1,Dv1] = f_armonici (t, x , v);
 		[Dx2,Dv2] = f_armonici(t+Dt/2, x+Dx1/2, v+Dv1/2);
 		[Dx3,Dv3] = f_armonici(t+Dt/2,x+Dx2/2, v+Dv2/2);
 		[Dx4,Dv4] = f_armonici(t+Dt, x+Dx3, v+Dv3);
		Dx = (Dx1+2*Dx2+2*Dx3+Dx4) /6; 
		Dv = (Dv1+2*Dv2+2*Dv3+Dv4) /6; 		
		tn=t+Dt;
		xn=x+Dx;		
		vn=v+Dv;		
 		line([t  tn],[x  xn],'color','y','linewidth',1)
		t=tn;
		x=xn; 
		v=vn;
	end
%	===========================================
% 	Qui si riporta la funzione che deve essere scritta in un file a parte per essere richiamata
%	dal programma riportato sopra la linea ======
%    	   	function [Dx,Dv] = f_armonici (t, x, v);
% %	------------------------------------------------------------------------  
% 	global  k  m  Dt
% % 	richiamata da "RungeKutta2.m"  
% %	per l'equazione dei moti armonici: m x''(t) = -k x(t)
% %	scritta come sistema dinamico 	
% %	x'(t)=F[ t, x(t),  v(t) ] 		x'(t) = v(t)
% %	v'(t)=G[ t, x(t),  v(t) ]		v'(t) = -k/m x(t)
% %	------------------------------------------------------------------------  
% 	Dx = + Dt * v;
% 	Dv = - Dt * k / m * x;

 
 
