%           DA METTERE A POSTO
%========================================
%           animazione  pendolo.m
%   poco soddisfacente: da capire meglio
%    grandi oscillazioni del pendolo
%========================================
% Si considera un pendolo (filo+pallina) 
% che compie grandi oscillazioni potendo 
% anche compiere un giro completo. 
% Considerato l'angolo "theta" tra il 
% pendolo e la verticale si divide 
% l'angolo tra 0 e 2pigreco in "n" parti.
% L'angolo theta e' stato indicato con 
% "A(k)" mentre la velocita' angolare omega
% e' stata indicata con "B(k)"
% Richiamato lo script "linea.m"

% Le quattro istruzioni che seguono possono
% essere attivate o disattivate secondo le
% necessita'. Meglio metterle tutte.

  	close  	% chiudi la finestra grafica 
% 	clf  	% pulisci la finestra grafica 
  	clear 	% libera la memoria
	clc 	% pulisci finestra comandi
%----------------------------------------
%  		dati
%----------------------------------------
	r=0.20; 	% m
	m=0.020; 	% kg
	g=9.81; 	% m/s/s
	n=1000;		% numero suddivisioni 
	h=2*pi/n; 	% passo integrazione
 	v0= 80; 	% m/s  
	fs=0.1; 	% fattore scala forze
% valore minimo della velocita' iniziale
% per far compiere un giro completo.
	vc=sqrt(5*g*r); % m/s
	v0= vc+0.8; 	% m/s
	n=8;
% prealloca spazio per la matrice
% (digitare  "help getframe")
% M e' una matrice di n colonne
% ciascuna corrispondente ad un fotogramma
% ed ogni riga contiene una fila di 0 e di 1 ?
		
%----------------------------------------
%     processo di integrazione
%----------------------------------------
% Si noti che in MATLAB il primo indice di 
% una array non puo' essere zero.
	k=1; 		% contatore passi 
	A(k)=0;  	% angolo alfa iniziale
	B(k)=v0/r; 	% vel angolare iniziale
	T(k)=m*(r*B(k)^2+g*cos(A(k))) ;
 	x(k)=+r*sin(A(k));  
	y(k)=-r*cos(A(k));

% Ciclo di integrazione	
% Si inizia un ciclo che deve proseguire
% fintanto che si realizzano tutte le tre
% condizioni seguenti: 
% 1) la tensione deve essere positiva: T(k)>0
% 2) la velocita' angolare e' positiva:B(k)>0;
% 3) l'angolo inferiore a 2 pi: A(k)<2*pi.
% Si noti che per il ciclo "while" alle 
% variabili che determinano l'arresto del
% ciclo si devono assegnare dei valori di
% partenza. 
%----------------------------------------
% il simbolo "&" sta per "and"
	while T(k) > 0 & B(k)>0 & A(k)<2*pi;
		k=k+1;
		A(k)=A(k-1)+B(k-1)*h;
		B(k)=B(k-1)-g/r*sin(A(k-1))*h;
		
% avevo dimenticato di moltiplicare per h 
% la seconda equazione! 
% ho perso ore per scoprirlo!

% Eventuale scrittura velocita' angolare
 		if B(k)<0; disp(B(k)); end
% calcola la tensione  del filo
		T(k)=m*(r*B(k)^2+g*cos(A(k)));
% e le coordinate della pallina	
 		x(k)=+r*sin(A(k));  
		y(k)=-r*cos(A(k));
	end		
%----------------------------------------	
% Traccia alcuni fotogrammi (ricorda "hold on") 
% altrimenti traccia solo l'ultimo fotogramma
	hold on
	plot(0,0,'y*'); % pallina

	j=1;
	for k=1:4:size(A,2)  % ogni 4 integrazioni
		X(j)=x(k);Y(j)=y(k);
		AA(j)=A(k); BB(j)=B(k);
		TT(j)=T(k);
		j=j+1;
	end
	
	clear A B T x y ;
	
	for j=1:size(X,2)
   		plot(X(j),Y(j),'yo'); % pallina
% traccia il filo
% 		linea(0,0,X(j),Y(j),'c',1);
% peso
		YY=Y(j)-m*g*fs;
 		linea(X(j),Y(j),X(j),YY,'g',3);
% tensione filo
 		Tx=-TT(j)*sin(AA(j));  Ty=+TT(j)*cos(AA(j));
		XX=X(j)+Tx*fs ; YY=Y(j)+Ty*fs;
   		linea(X(j),Y(j),XX,YY,'r',2);
% forza centrifuga			
  		F=m*r*BB(j)^2;
		Fx= F*sin(AA(j));  Fy=-F*cos(AA(j));
		XX=X(j)+Fx*fs ; YY=Y(j)+Fy*fs;
  		linea(X(j),Y(j),XX,YY,'b',2);
% traccia assi x ed y
%	linea(-0.35,0,0.35,0,'c',1)
%	linea(0,-0.35,0,0.35,'c',1)
		
% axis([Xmin  Xmax  Ymin  Ymax])			
	axis([-0.35   0.35   -0.35   0.35]) 
	axis off 	% non traccia gli assi 
	axis equal 	% immagine isometrica
% cattura il fotogramma numero "k"
  	M(:,j)=getframe;
	end

	pause
% mostra i fotogrammi in successione per
% 8 volte con 2 fotogrammi al secondo
	movie(M,2,0.5) 	
   

%========================================
