%	====================================================
%			       baseRulletta 
%	====================================================
%  	Visualizza la polare fissa (base) e quella mobile (rulletta) di un'asta AB 
%     che si muove con gli estremi su due assi ortogonali. 
%	----------modalit grafica--------------
	close ; h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	 whitebg(h1, 'black')
	hold on ; zoom on ; pause on
	axis equal ; axis([-3.2   3.2   -3.2   3.2]);
% 	 ---------------------  Dati  ----------------------------
	L = 3;		% lunghezza asta in m
	n = 10;		% numero fotogrammi 
	p = 2 * pi / n;	% passo angolare
	a=1.2*L;		% lunghezza assi in m
%  	 ------------------Traccia ------------------------------ 
	line([ 0  0],[-a   a],'color','r');	% asse orizzontale
	line([-a   a],[ 0  0],'color','r');	% asse verticale
%	polare fissa o base del moto
	A= 0 : 0.12 :2*pi;	% crea array degli angoli
	X = L*cos(A)	;	Y = L*sin(A);
	plot(X,Y,'r')
	pause
	for k = 2 : n
		a = k*p;					% angolo con l'asse verticale
		xA = L * sin(a); 	yA = 0;	% punto A sull'asse orizzontale
		xB = 0; 	yB = L * cos(a);	% punto B sull'asse verticale
%		
%		polare mobile o rulletta
		xM = (xA+xB)/2; 	yM = (yA+yB)/2;  % punto medio asta
		D= 0 : 0.12 : 2*pi;	% crea array degli angoli
		U = xM+L/2*cos(D) ; V = yM+L/2*sin(D); % array per la circonferenza
		plot(U,V,'c','era','back');		% traccia polare mobile
% 
		plot([xA yA],[ xB   yB],'color','y','era','back');	% asta AB
		plot([xA  xA],[0  yB],'color','y','linestyle',':','era','back'); 	% tratto verticale
		plot([0  xA],[yB  yB],'color','y','linestyle',':','era','back');	% tratto orizzontale
		plot( xA,yB ,'r.','linewidth',5,'era','back');	 	% centro di istantanea rotazione
		pause
	end;  
%  	 ------------------------------------------------- fine 
 
