%	===========================================
%       		CAMPODIREZ
%	===========================================
%  	Data una equazione differenziale del primo ordine in forma normale, y'=f(x,y) 
%  	e considerati i nodi di un reticolo cartesiano, si traccia in ciascuno di essi
%  	la direzione della tangente alla linea passante per il punto.
% 	Quindi clickando in un punto generico si mostra la soluzione passante per quel punto.
%	-------------------------------------------------------------- 
%			seleziona modalita' grafica 
%	-------------------------------------------------------------- 
	close ; clc; 		
	h1 = figure(1); 	
% 	set(h1, 'Units', 'normalized', 'Position', [0.5 0.5 0.5 0.5]);
	set(h1, 'Units', 'normalized', 'Position', [0 0.1  1  1]);
% 	colore di fondo
  	whitebg(h1, 'black')
	xi = 0; 	xf = 4; 	yi=0;  	yf=0.5;
	axis([xi  xf  yi  yf ]);
	hold on ; 
%	-------------------------------------------------------------- 
%					scritte
%	-------------------------------------------------------------- 
 	h3 = title('campo di direzioni');
 	set(h3,'fontsize',24,'color','yellow','fontname','times');
	h2 = text(xi,yi-0.03,'per uscire cliccare fuori riquadro');
 	set(h2,'fontsize',18,'color','cyan','fontname','times');
	xlabel('x');
	ylabel('y');
%	-------------------------------------------------------------- 
% 	Costruiamo un reticolo di punti 
	px = 0.3; 	% passo del reticolo
	py = 0.05; % passo del reticolo
	L = 0.06;  	% semilunghezza trattini
 	X = xi : px : xf; 	n=size(X,2); 	% primo array e numero di elementi
	Y = yi : py : yf;  	m=size(Y,2);	% secondo array e numero di elementi
%	-------------------------------------------------------------- 
%			traccia campo direzioni
%	-------------------------------------------------------------- 
	for j=1:m;  
		y= j*py;	
 		for i=1:n
			x = i*px;	
			plot(x,y,'c*','linewidth',1,'era','back')			
 			% funzione:  y = x *exp(-x)
   	 		deriv = exp(-x) - y;			% derivata della funzione
			co = 1/sqrt(1+deriv*deriv); 	% coseno dell'angolo
			se = co *deriv; 			% seno dell'angolo
 	   		dx = L*co;  	dy=L*se;	% proiezioni dei semitrattini
 	   		x1 = x-dx; 	y1=y-dy; 		% primo estremo del trattino
 	   		x2 = x+dx ;	y2=y+dy;		% secondo estremo del trattino
 	   		plot([x1  x2],[y1  y2],'c','linewidth',1,'era','back')
		 end;  
	 end
%	-------------------------------------------------------------- 
%			traccia curve integrali
%	-------------------------------------------------------------- 
%	rileva punto iniziale
	h  = 0.1; 
%	ora traccia la curva integrale che rappresenta la soluzione
	x0=xi; y0=yi;  % valori fasulli per entrare nel ciclo "while"
	while x0 >= xi & y0 >= yi & x0 <= xf & y0 <= yf
		[x0,y0]=ginput(1);
% 		traccia solo se hai "cliccato" dentro
		if x0 >= xi & y0 >= yi & x0 <= xf & y0 <= yf
			plot(x0,y0,'y*','era','back')
			X = x0 : h : xf ;	% crea l'array da "x0" ad "xf"
			n=size(X,2); 		% componenti del vettore riga
 			Y=zeros(1,n); 		% preassegna un vettore "y" di
			% uguale lunghezza del vettore "x" formato da zeri

			k=1 ;  X(k) = x0;  Y(k) = y0; 
			for k=1:(n-1) 
				Y(k+1) = Y(k) + h*f_caio(X(k),Y(k)); 
			end
			plot (X,Y,'y','linewidth',1,'era','back');
		end
	end
%	===========================================
