%			CATENARIA
%	Traccia la catenaria e calcola i parametri
%	Faremo riferimento al documento "catenaria.tex"
%
%	clear all
%	-------------------- dati ----------------------	
 	L = 40; 	% lunghezza in cm
	d = 20; 	% distanza orizzontale tra gli appoggi
	P = 100; 	% peso in grammi
	p = P/L;   	% peso per unita' di lunghezza

if 1 == 1
%	-----------------------------------------------------
%		CALCOLA I PARAMETRI
%	-----------------------------------------------------
%  	assegnati L ,  P ,  d trovare h con l'equazione cL = sinh (cd)
% 	attiva la grafica
	close ; h1  =  figure(1) ; 	
 	set(h1 ,  'Units' ,  'normalized' ,  'Position' ,  [0.5  0.5  0.5  0.5]) ; 
	axis([-0.2  0.2  -2  2]);
	line([-1  1] ,  [0  0])
	hold on; grid on; zoom on
%	grafico
	C = -0.2 : 0.01 : 0.2;
	U = C*L-sinh (C*d);
	plot(C , U)
% 	dal diagramma vedo che la funzione si annulla in zero 
%	e intorno ai valori 0.05 e -0.05. Per trovare un valore piu' preciso
%	uso la funzione "fzero" 
	stringa = 'x*40-sinh (x*20)';  % devo mettere la lettera x
 	c = fzero(stringa ,  0.07)
%	fare attenzione: se metto 0.07 lo zero che trova e' in zero!
% 	dal momento che c = p/ (2h) e  si ricava
	h = p/(2*c)  
%  	ad esempio con L = 40 ,  P = 100 ,  d = 25 ,  p = P/L = 2.5 
%	viene c = 0.070279 ed  h = 17.786234
% pause
end

 if 1 == 1
%	-----------------------------------------------------
%		TRACCIA IL GRAFICO
%	-----------------------------------------------------
%	------------------modalit grafica--------------------
	close ; h1  =  figure(1) ; 	
%	set(h1 ,  'Units' ,  'normalized' ,  'Position' ,  [0  0  1  1]) ; 
 	set(h1 ,  'Units' ,  'normalized' ,  'Position' ,  [0.5  0.5  0.5  0.5]) ; 
 	whitebg(h1 ,  'w') 	% 	colore di fondo
	hold on ; axis on ; zoom on; grid on
	axis equal  
	axis([-12  12  -2  22]);
%	--------------------assi cartesiani----------------------	
	xmin = -d/2; xmax = d/2;
	f_vettoreX(xmin ,  0 ,  2*xmax ,  'k' ,  0.5 , 0.5)
	f_vettoreY(0 ,  0 ,  22 ,  'k' ,  0.5 , 0.5)
	text(xmax , 0.4 , 'x', 'fontsize', 18, 'fontname','times');   
	text(0.4 , 21 , 'y' , 'fontsize', 18, 'fontname','times'); 
	text(0.4 , 3.4 , 'h/p', 'fontsize', 18, 'fontname','times'); 
 %	------------------- diagramma -------------------------
	X  =  xmin : 0.1 : xmax; 
	Y  = h/p*cosh(p/h*X); 		   
	plot(X , Y , 'color' , 'k');
	xs = -d/2; ys = h/p*cosh(p/h*xs); 	f_cerniera(xs , ys , 0.3 , 'w' , 'k')
	xd = +d/2; yd = h/p*cosh(p/h*xs); f_cerniera(xd , yd , 0.3 , 'w' , 'k')
end
if 1==1
%	---------------------------------------------------------
%		DIVIDO IN PARTI UGUALI
%	---------------------------------------------------------
	e = L/10;
	x2=-d/2; x1=-d/2;
	k=0; 
	x(1)=x1;
	y(1) = h/p*cosh(p/h*x(1));
	while x2 <= d/2
		x2=h/p*asinh(p/h*e+sinh(p/h*x1));
		y2 = h/p*cosh(p/h*x2);
		k=k+1;
		x(k)=x2; y(k)=y2;
		x1=x2;
	end
	kmax=k;
	for k = 1 :  kmax
		f_cerniera(x(k) , y(k) , 0.2 , 'w' , 'k')
	end
%	---------------------------------------------------------
%		CATENARIA DISCRETA
%	---------------------------------------------------------
	
end

%	---------------------------------------------------------fine
