%	DIFFUSIONE
%
% da fare con R-K
%
%		Questo programma illustra il moto di una particella elettrica
%	carica positivamente che viene lanciata
%	contro una particella carica fissa di carica pure positiva.
%	Ad esempio di una particella alfa contro il nucleo di un atomo.
%	Assegnata la velocit iniziale della particella 
%	mediante le due componenti radiale e trasversale 
%	si visualizza la posizione della particella 
%	ad intervalli uguali di tempo.  
%	----------modalit grafica--------------

	close ; h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	hold on ; axis on ; zoom on ; pause off ; grid on
	axis equal ; axis([-8  8  -8  8]);
%	-----------------------------------------------------------
	xA = -2 ; yA = 0;	% coordinate del nucleo
	m = 0.001;		% massa particella in kg
	q = -0.1;			% costa-nte forza centrale 
	dt = 0.01;		% incremento tempo in secondi	plot([-8  8],[0  0],'color','r','linewidth',1,'era','back')
	a0 = 0;			% angolo iniziale in radianti
	r0 = 8;     		% raggio iniziale in metri
	x0 = xA + r0 * cos(a0); 	y0 = yA +r0 * sin(a0);
	vr0 = 0 ; vt0 =2.5; % velocit radiale e trasversa iniziali
	c = 1 / 2 * r0 * vt0;     %velocit areale
%	-----------------------------------------------------------
%	Disegna il nucleo mediante un cerchio pieno
%	e la particella nella posizione iniziale	
	plot(xA,yA,'b.','linewidth',9,'era','back')
 	plot(x0,y0,'r.','linewidth',4,'era','back')
%	assegna valori iniziali
	t = 0; 	r = r0;	 a = a0;	 vr = vr0; 	vt = vt0;
	x = xA + r0 * cos(a0); 	y = yA + r0 * sin(a0);	
% 	metodo di integrazione di Eulero
	while  x>-8 & x<8 & y>-8 & y<8
		rn = r + dt * vr;
		an = a + dt * 2 * c / (r*r);
		vrn = vr + dt * (4 * c*c / (r*r*r) + q/m / (r*r) );
		r = rn ; a = an ; vr = vrn ; % aggiorna variabili
		x = xA +  r * cos(a);  y = yA + r * sin(a);
		plot(x, y,'r.','linewidth',4,'era','back')
	end
	

