%========================================================= 
%       	campo di direzioni
%---------------------------------------------------------
%  Data una equazione differenziale del primo ordine
% in forma normale, y'=f(x,y) e considerati i nodi
% di un reticolo, si traccia in ciascuno di essi
% la direzione della tangente alla linea passante per
% il punto.
%  Successivamente puntando il mouse in un punto della
% finestra grafica e facendo il click si visualizza la
% linea integrale passante per tale punto. 

	clear  	% azzera la memoria
	clc   	% pulisci la finestra comandi
 	close	% chiudi una precedente figura
	hold on	% indispensabile quando si devono fare 
			% tanti tracciamenti
% Assegnamo gli estremi dell'intervallo in x ed y 
% nonche' il passo del reticolo in x ed y.
	xi=0;   xf=8 ; yi=0;  yf=7;  dx=1;   dy=1;
% Costruiamo un reticolo di punti 
 	x=xi:dx:xf; 	ni=size(x,2); 	
	y= yi:dy:yf;  	nj=size(y,2);
	
	p=0.1;  % semilunghezza trattini
	for j=1:nj;   
	 for i=1:ni
 	   g =funzione(x(i),y(j)); 	
	   ca=p*1/sqrt(1+g*g); % coseno dell'angolo*p
	   sa=p*g/sqrt(1+g*g); % seno dell'angolo*p 
	   x1=x(i)-ca ; y1=y(j)-sa;
	   x2=x(i)+ca ; y2=y(j)+sa;
	   linea(x1,y1,x2,y2,'c',0.5)
	   plot(x(i),y(j),'y.','era','back')
	 end;  
	end
% cancella i vettori dalla memoria
% per poter usare le stesse lettere in seguito
	clear x y 
% scritte
    text(xi+4,yf+0.1,'campo di direzioni',...
 				'fontname','MS Sans Serif', ...
				'fontsize',18,'color', 'c')
	text(xi,(yi-0.5),...
	'per uscire clicca a sinistra dell''asse y',...
	'color', 'c');

 	axis([xi xf yi yf])
	h=0.1; 	% passo di integrazione
% valore fasullo di "a" per poter entrare nel ciclo 
	a=1; 	
	while a>0	
		[a b]=ginput(1);  % click sulla finestra grafica
		if a>0
 			plot(a,b,'c*','era','back') % traccia asterisco
			x=a:h:xf; % crea l'array da "a" alla fine "xf"
			n=size(x,2); % comonenti del vettore riga
 			y=zeros(1,n); % preassegna un vettore "y" di
			% uguale lunghezza del vettore "x" formato da zeri
			k=1; y(k)=b;
			for k=1:(n-1)  % perche' c'e' il (k+1)
 				y(k+1)=y(k)+funzione(x(k),y(k))*h;
			end
			s=plot(x,y,'color','c','linewidth',0.5,'era','back');
		end
 	end
%========================================================= 
