%	====================================================
%			       dueAste1  (per dueAste.m)
%	====================================================
%  	Visualizza le posizioni di equilibrio di due aste AC e CB di uguale lunghezza L
%	incernierate fra loro in C. L'estremo A e' incernierato a terra mentre l'estremo B
%	e' scorrevole lungo l'asse delle ascisse.
% 	 -------------------------------------------------------
%		ATTIVA  GRAFICA
% 	 -------------------------------------------------------
	close ; clc; clear all
	h1 = figure(1) ; 	
%	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
  	whitebg(h1, 'black')
	hold on 
 	h2=title('forza agente su due aste incernierate');
	set(h2,'color','yellow','fontsize',18)
	h3=xlabel('ascissa estremo B');
	set(h3,'color','green','fontsize',12)
	h4=ylabel('fattore di amplificazione');
	set(h4,'color','green','fontsize',12)
% 	 -------------------------------------------------------
%		DATI
% 	 -------------------------------------------------------
	L = 98;		% lunghezza asta in cm
	P = 0.1;		% peso dell'asta in N
	a = 0.5*L;	%  
	k = 2.1;		% costante molla N/cm
	s0 = 51;		% lunghezza molla a riposo in cm
	x0=L/a*s0;	% minima ascissa del punto B
 	N = 20;		% suddivisione intervallo
	p = (2*L-x0)/N;	% passo 
% 	 -------------------------------------------------------
%		TRACCIA GRAFICO
% 	 ------------------------------------------------------- 
	for i=1: (N-4)
	  	X(i)= x0+ i*p; 
		radice=sqrt(L^2-(X(i)/2)^2); 
		num=k*a/L*(a*X(i)/L-s0)*4*radice;
 		F(i)=num/X(i)-P;
 	end
	plot(X,F);
%  	 ------------------------------------------------- fine 
 
