%	 moto armonico smorzato e forzato
%			xp(t) = R cos(wi t +b)
%			m DDx(t) + h Dx(t) + k x(t) = f0 sin(wi t)
%	----------modalita' grafica--------------
	close ; h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	hold on ; zoom on ; pause on
	whitebg('k')
% 	---------------------  Dati  ----------------------------
	A=4; B=2;
	T = 0 : 0.01 :10;
	k=5;		% costante molla
	h=0.1;		% coefficiente resistenza
	m=0.1;		% massa
	eps=h/(2*m);	% costante di smorzamento
	w0= sqrt(k/m);	% pulsazione naturale
% 
 	wi=6; 	% pulsazione impressa: risonanza 7.07
	q0=1; 	% fase iniziale
	f0=4;	% forza 
	xstatico=f0/(m*w0^2); % elongazione statica 
	beta = atan(-2*eps*wi/(w0^2-wi^2)); % fase 
	F = f0/m*1/((w0^2-wi^2)^2 +(2*eps*wi)^2); % coeff amplific. dinamico 
% -------------------
%	OSSERVAZIONE: subplot(righe, colonne, numero del riquadro)
% -------------------
%	forza nulla     
	subplot(3,2,1) % quadro 1 (alto-sinistra)
 	U = 0;
  	plot(T,U,'c')
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
	axis([0  10   -6   6]);
	title('forza nulla','fontsize',18)
	pause
% -------------------
%	smorzato
	subplot(3,2,2)	% quadro 2 (alto-destra)
	X = exp(-eps*T).*(A*cos(-w0*T)+B*sin(w0*T));
  	plot(T,X,'y')
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
 	axis([0  10   -5   5]);
	hold on
	title('elongazione','fontsize',18)
	pause
% -------------------
%	forza costante f0   
	subplot(3,2,3) % quadro 3 (medio-sinistra)
 	U = f0;
  	plot(T,U,'c')
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
	axis([0  10   -6   6]);
	title('forza costante','fontsize',18)
	pause
% -------------------
%	smorzato
	subplot(3,2,4)	% quadro 4 (medio-destra)
	X = exp(-eps*T).*(A*cos(-w0*T)+B*sin(w0*T))+xstatico;
  	plot(T,X,'y')
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
 	axis([0  10   -5   5]);
	hold on
	title('elongazione','fontsize',18)
	pause
% -------------------
%	forza sinusoidale 
	subplot(3,2,5)	% quadro 3 (basso-sinistra)
 	f = f0*cos(wi*T);
  	plot(T,f,'c')
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
	axis([0  10   -6   6]);
	title('forza sinusoidale','fontsize',18)
	pause
% -------------------
%	forzato
	subplot(3,2,6)	% quadro 4 (basso-destra)
	X = exp(-eps*T).*(A*cos(-w0*T)+B*sin(w0*T))+xstatico*F*cos(wi*T+beta);
  	plot(T,X,'y')
 	axis([0  10   -5   5]);
	line([ 0  10],[0   0],'color','g');	% asse orizzontale
	title('elongazione','fontsize',18)

	
	
