%	========================================================================
%      					grandiOscillazioni.m
%	========================================================================
%   Integrazione equazione differenziale  u''(t)= -L/g sin(u(t))
%   con il metodo di Runge-Kutta del 4 ordine.
% 		u'(t) = v(t)
%		v'(t) = - L/g sin(u)
% 	chiama "f_grandi"
%	------------------------------------------------------------------------
 	clear 				% azzera le variabili in memoria
	clc					% pulisci finestra di testo
	global g  L  Dt  	% dopo il clear !
%	------------------------------------------------------------------------
%		 seleziona modalita' grafica 
%	------------------------------------------------------------------------
% 	chiudi finestra grafica precedente	
%	close		
% 	apre una finestra grafica di dimensioni volute
	h1 = figure(1); 	
%	set(h1, 'Units', 'normalized', 'Position', [0.5 0.5 0.5  0.46]);
	set(h1, 'Units', 'normalized', 'Position', [0 0  1  0.90]);
% 	colore di fondo
  	whitebg(h1, 'black')
%	assi di dimensioni volute
%	axis([0 20 -1.2 1.2] );  % [xmin xmax ymin ymax]
	hold on
	grid on
	zoom on
	title('integrazione col metodo di Runge-Kutta del 4Infinity ordine');
	xlabel('t');
    ylabel('u');
%	------------------------------------------------------------------------
	g=9.81; 		% m/s/s
	L=1; 			% metri
	tf=100;			% secondi
	n=3000;			% suddivisioni
	Dt=tf/n			% passo temporale in secondi
	t(1)=0;			% istante iniziale
	u(1)=0.95*pi;	% angolo iniziale
	v(1)=0; 		% velocita' iniziale

	for i=1:n
		[Du1,Dv1] = f_grandi(t(i), u(i), v(i)) ;
 		[Du2,Dv2] = f_grandi(t(i)+Dt/2, u(i)+Du1/2, v(i)+Dv1/2) ;
 		[Du3,Dv3] = f_grandi(t(i)+Dt/2, u(i)+Du2/2, v(i)+Dv2/2) ;
 		[Du4,Dv4] = f_grandi(t(i)+Dt,  	u(i)+Du3, 	v(i)+Dv3/2) ;
		Du = (Du1+2*Du2+2*Du3+Du4) /6; 
		Dv = (Dv1+2*Dv2+2*Dv3+Dv4) /6; 		
		t(i+1)=t(i)+Dt;		
		u(i+1)=u(i)+Du;	
		v(i+1)=v(i)+Dv;	
  	end
%	------------------------------------------------------------------------  
%	 		grafico dell'angolo
%	------------------------------------------------------------------------  
	subplot(2,1,1)
   	axis([0 tf  -3.16 3.16] );  % [xmin xmax ymin ymax
	plot(t,u,'g')
  	grid on
  	title('grandi oscillazioni pendolari');
	xlabel('tempo');
	ylabel('angolo','color','y');
%	------------------------------------------------------------------------  
%	 		grafico della velocit angolare
%	------------------------------------------------------------------------  
	subplot(2,1,2)
  	plot(t,v,'g')
	grid on
  	title('integrazione col metodo di Runge-Kutta del 4 ordine');
	xlabel('tempo');
	ylabel('velocit','color','g');
%	========================================================================
%    	   	function [Du,Dv] = f_grandi (t, u, v);
% %	------------------------------------------------------------------------  
% 		global g  L  Dt
% % 	richiamata da "grandiOscillazioni.m"  
% %		per l'equazione dei moti armonici:   u''(t) = -L/g sin(u(t))
% %		scritta come sistema dinamico 	
% %		u'(t) = v(t)
% %		v'(t) = - L/g sin(u(t))
% %	------------------------------------------------------------------------  
% 		Du = + v * Dt;
% 		Dv = - L/g * sin(u) * Dt;

 
 
