 %	 *******************************************
%        			 GRAVIRES
%	 *******************************************
%
%	Moto dei gravi nell'aria
% 	Il programma mostra il moto di un grave con la resistenza dell'aria.
%	Attenzione: aumentando il coefficiente H oppure la velocita' iniziale v0
%	si incorre in incongruenze. Queste sono dovute al fatto che la presenza
%	di una resistenza proporzionale al quadrato della velocita' il coefficiente 
%	"h" deve essere contenuto entro certi valori
%					m *a = m* g - h* v*v* t
%	mx" = 0 -h (x'x'+y'y') tx  		my" = -mg -h(x'x'+y'y') ty
%	
%	----------modalit grafica--------------
	close ; h1 = figure(1) ; 	
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
	hold on ; axis on ; zoom on ; pause on ; grid on ;
 	axis equal ;    axis([-2  20  -8  8]);
	clc
%	-------------------------Dati---------------------------------
	x0 = 0;  y0 = 0;		% posizione iniziale (m)
	v0 = 12;			% velocit iniziale (m/s) 
	a = 60 * pi / 180;	% angolo di alzo (rad)
	vx0 = v0 * cos(a);	% componente x della velocit iniziale (m/s)	
	vy0 = v0 * sin(a); 	% componente y della velocit iniziale (m/s)
	m = 0.8;			% massa (kg)
	g = 9.81;			% accelerazione di gravita (m/s/s)
	h = 0.1;			% coefficiente di resistenza(N*m*m/s/s)
	dt = 0.1; 			% intervallo di tempo (s) 
	tf = 10; 			% tempo finale (s)	
 %	-----------------------------------------------------------
%	assi cartesiani
	f_vettoreX(0, 0, 18,'k', 1, 1,0.4);
	f_vettoreY(0, 0, 7,'k', 1,  0.4, 1);
%	----------------scritte---------------------------- 
 	w(1) = text(18 ,1,'x'); w(2) = text(-1,7,'y');
	set(w, 'fontsize',18,'fontname','times');
%	-----------------------------------------------------------
	t = 0; 
	x = x0;
	y = y0;  
	vx=vx0 ; 
	vy =vy0 ;
 	pause
	for t = 0 : 0.1 : 20;	 	
   		tn = t + dt; 
 		xn = x + vx*dt ; 
 		yn = y + vy*dt;
 		ss = sqrt(vx*vx+vy*vy); 
 		vxn =  vx+ (-h/m*vx*ss)*dt;		
 		vyn = vy - g*dt + (- h/m*vy*ss)*dt;	
		t = tn ;
 		x = xn ;
 		y = yn ; 
  		vx = vxn; 
   		vy = vyn; 		
 % 		traccia il punto
		f_circo(x, y, 0.12,'r')
	end	
% -----------------------------------------------------------------------fine
