% ---------------------------------------------------------------------
%  			OSCILLATORE SEMPLICE  
% ---------------------------------------------------------------------
%	Il programma mostra il moto oscillatorio smorzato 
% 	L'equazione differenziale e':
%		m DDx(t) + h Dx(t) + k x(t)  = 0
% 	la soluzione generale e'
%   	x(t) = M exp(- del t) sin(w t + a) 
% 	essendo
%		del = h/(2m)
%   	w = sqrt(w0^2-del^2)
%		M ed A costanti da determinare con le condizioni iniziali x0 e v0
% 	assegnati i valori iniziali x0 e v0
%		w  	sta per omega
%		w0 	sta per omega0
%		a  	sta per alpha    
%  	del	sta per delta  
% ---------------------------------------------------------------------
	clear all   % cancella tutte le variabili in memoria  
 	close 		% chiudi tutte le finestre grafiche
	clc			% azzera la finestra dei comandi
% ---------------------------------------------------------------------
%	attiva la grafica
	h1 = figure;
%	set(h1, 'Units', 'normalized', 'Position', [0  0  1  0.92]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.40]); 
	whitebg(h1,'k')
	hold on; grid on; zoom on
	axis([0  1  -8  8])
	line([0  1],[0   0],'color','r','linewidth',1)
% 	DIDASCALIE sugli assi
 	h3 = xlabel('tempo');
  	set(h3,'color','y','fontsize',14,'fontname','times')
  	h4 = ylabel('elongazione');
  	set(h4,'color','y','fontsize',14,'fontname','times')
% ---------------------------------------------------------------------
%	parametri del sistema 
%	se k = 400 e m=1: h=4 subcritico;  h=40 critico;  h=50 supercritico
	k   = 400;	% rigidezza
	h   = 90;		% coefficiente di smorzamento: 
 	m   = 1;		% massa
%  
	w0  = sqrt(k/m) % pulsazione naturale del sistema
 	del = h/(2*m) 	% costante di smorzamento		
% ---------------------------------------------------------------------
%  	condizioni iniziali   
  	x0 = 5;		% elongazione iniziale in metri
	v0 = 20;    % velocita' iniziale m/s
% ---------------------------------------------------------------------
	t  = 0 : 0.001 : 1;	% array dei tempi
%
    if del > w0 		%  sistemi sovrasmorzati
		disp('smorzamento sovra-critico')
		mu = sqrt(del^2-w0^2);
		A = (mu*x0-del*x0 -v0)/(2*mu);
		B = (mu*x0+del*x0 +v0)/(2*mu);
      x = exp(-del*t).*(A*exp(-mu*t) +B*exp(mu*t));
     	plot(t,x,'linewidth',2,'color','c')
    end
%
	if del == w0 	%  smorzamento critico
		disp('smorzamento critico')
		A = x0;
		B = v0+del*x0;
      x = (A+B*t).*exp(-del*t);
    	plot(t,x,'linewidth',2,'color','m')
    end
%
    if del < w0  		%  sistema sottosmorzato
		disp('smorzamento sub-critico')
		w = sqrt(w0^2-del^2); 	% pulsazione del moto smorzato  
		T = 2*pi/w; 			% periodo del moto smorzato 

% 		trovare M ed alpha
		M = sqrt(x0^2+(v0+del*x0)^2/w^2);
% 		La funzione "asin" (arcsin) fornisce l'angolo tra -90 e 90: 
%		per avere l'angolo tra 90 e 270 occorre scrivere a = pigreco-a
		a = asin(x0/M); % fase iniziale
		if v0<0; a   = pi-a; end
%
		x = M*exp(-del*t).*sin(w*t+a);
    	plot(t,x,'linewidth',2,'color','y')
    end

% ---------------------------------------------------------------------




