%====inizio========================= 
%       	 		         polo1
%---------------------------------------------------------
% Attenzione!  MATLAB segnala un errore
% indicando l'ultima riga corretta. L'errore quindi
% va cercato nella riga successiva.
%
% Assegnate alcune forze nel piano determinare il
% momento rispetto ad un polo Q.
% Questo programma deve essere prededuto da polo.m
	clear  	% azzera la memoria
	clc   		% pulisci la finestra comandi
% Chiudi eventuali finestre aperte: questo
% consente di far venire in primo piano la nuova
% finestra grafica mettendola al centro dello schermo.
	close
% Tieni aperta la figura per tracciamenti successivi	
	hold on			  
% Assegnamo i punti di applicazione delle forze,
% inserendo le loro ascisse e le loro ordinate in
% in due matrici: 
	x=[2 1 3];	% ascisse
	y=[1 3 2];	% ordinate
% ( gcf = g-et c-urrent f-igure handle)
	set(gcf,'Color','k')  % fissa il colore di fondo nero
	set(gcf,'DefaultTextColor','w')
    title('Momento di un sistema di forze');
% se si vuole questa visualizzazione parziale (con "pause")
% bisogna mettere l'istruzione "axis" gia' qui. 
	axis([0 4 0 4])			
 
% Assegna le componenti delle singole forze mediante
% un array
	Fx=[ 5   0   1.4];
	Fy=[ 0  -4   2];
 	for k=1:3
		vettore(x(k),y(k),Fx(k),Fy(k),'g',3)
 	end
	grid     % traccia la griglia
	hold on  % consente di sovrapporre successivi tracciamenti

% Inizia un ciclo che fissa il polo Q col mouse
% e termina facendo "click" a sinistra dell'asse "y"
	xQ=3;  % valore fasullo per poter entrare nel ciclo
	while xQ>0
% Assegnamo le coordinate del polo Q col mouse
		[xQ yQ]= ginput(1);   
 		plot(xQ,yQ,'r+') % visualizza il polo Q con "+"
% il plot fa fare un salto ad ogni tracciamento: come
% evitarlo?   
% Calcoliamo i momenti delle singole forze
% rispetto al polo Q (la formula che segue si ottiene
% sviluppando il determinante simbolico che 
% fornisce il prodotto vettoriale  "(r-rQ) x F "
       	m1= Fy(1) * (x(1) - xQ) - Fx(1) * (y(1) - yQ) ; 
       	m2= Fy(2) * (x(2) - xQ) - Fx(2) * (y(2) - yQ) ; 
       	m3= Fy(3) * (x(3) - xQ) - Fx(3) * (y(3) - yQ) ;
% Momento totale
		m=m1+m2+m3;
% L'istruzione che segue consente di "stampare" sullo
% schermo (1) una frase ed un numero
		fprintf(1, 'momento =  %4.2f\n ', m);
	end
	hold off
%==========================fine======= 
