%	--------------------------------------------------------------------------------			
% 			 scivolaCerchio
%	------------------------------------------------------------------------------
%     Un grave scivola su una guida circolare liscia. Visualizza il moto,
%	il momento del distacco, la reazione vincolare ed il moto successivo.
%
%	--------------------------modalit grafica---------------------------------
	close ; h1 = figure(1) ; 	
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5 0.5  0.5]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0  0 1  1]) ; 
 	hold on ; pause on ; zoom on ; 
	axis equal ;  axis( [0 50 0 60] );  % [xmin xmax ymin ymax]
%	-------------------------------  dati ------------------------------ 	
	xC =  5 ;  yC = 5 ;  r = 30 ;  % tutto in metri
	m =  0.01 ;  	%  unit: kg
	g  =  9.81 ;  	%  unit:  m/s/s
	dt = 0.01; 		%  unit:  s
	fs  =  50 ;  		%  unit: cm/N
	th0 = 0.02; 	%  unit: rad Partenza poco discosta dalla sommit
	v0 = 0 ;  		%  unit: m/s
% 	-------------- traccia il vincolo circolare --------------
 	S = 0 : 0.08 : pi/2 ;   X = xC+r*cos(S) ;   Y = yC+r*sin(S) ; 
	plot(X,Y,'b') ; % riempie solo una lunula
%	completa il quarto di cerchio  riempiendo un triangolo 
	U=[xC,  xC+r,  xC,  xC] ; V=[yC , yC,  yC+r,  yC];
%	plot(U,V,'b') ;  % (lo 0.02 e' un ritocco)
%	assi cartesiani 
	f_vettoreX(xC, yC, 40, 'y' , 0.9,   1.6,  1  ) ;  % ... spess, sL, sN
	f_vettoreY(xC, yC, 36, 'y' , 1,    1.6,  1  ) ;   % ... spess, sL, sN
%	----------------scritte---------------------------- 
 	h(1) = text(xC+40 ,yC+3,'y'); h(2) = text(xC-2,yC+ 36,'x');
	set(h, 'fontsize',18,'fontname','times');
% 	------ PRIMA FASE:-Il grave scivola sulla guida circolare--------
%	Integrazione con il metodo di Eulero.	
% 	Valori iniziali: tempo, angolo e velocit angolare
	t = 0 ; th = th0 ;  om = v0/r ; 
	reaz = -1 ; 	% valore negativo fasullo per poter entrare nel ciclo while	
	rr=r+ 0.6; 	% piccolo ritocco per disegnare la pallina che "tocca" la guida
	j = 0; 	   	% contatatore per tracciare i fotogrammi
 
 	while reaz <=  0 
		x = xC+rr*sin(th) ; 	y = yC+rr*cos(th) ; 
		% calcola e traccia la reazione (la normale  entrante)
		reaz = m*v0*v0 / r+2*m*g*(2-3*cos(th) );   % esterno:  negativa
		xx = xC+(r-reaz*fs)*sin(th) ; yy = yC+(r-reaz*fs)*cos(th) ;
		% escludi  l'ultimo fotogramma per il quale reaz > 0
		% e traccia la pallina ogni 12 intervalli di integrazione
 		if reaz <=0  &  mod(j,12) == 0
			f_circo(x,y,0.5,'y')
 			plot([x , xx], [y ,  yy],'linewidth',0.5,'color','r','era','back' );
			pause(0.2)
 		end
		% metodo di integrazione di Eulero
		th1 = th+om*dt ;   om1 = om+g/r*sin(th) *dt ; 
 		om = om1 ; 	th = th1 ;  t = t+dt ; 
		j = j+1;
	end ; 
% 	--------------SECONDA FASE-: caduta libera----------------------
% 	Condiz. finali fase preced. = condiz iniz. fase seguente		
	t0 = t ; x0 = x ; y0 = y ; v0 = om*r;  
	vx0 = v0*cos(th) ;  vy0 =- v0*sin(th);  	
  	while  y>yC
 		t = t + dt;
 		x = x0 + vx0*(t-t0) ;    y = y0 + vy0*(t-t0) - g/2*(t-t0)^2 ; 
   		if  mod(j,12) == 0 ; f_circo(x,y,0.5,'y');  end
		j = j+1;
 	end
% 	----------------------------------------------------------------------fine--------------






