%	--------------------------------------------------------------------------------			
% 			 scivolaCerchio
%	------------------------------------------------------------------------------
%     Un grave scivola su una guida circolare liscia. Visualizza il moto,
%	il momento del distacco, la reazione vincolare ed il moto successivo.
%
%	--------------------------modalit grafica---------------------------------
	close ; h1 = figure(1) ; 	
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5 0.5  0.5]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0  0 1  1]) ; 
 	hold on ; pause off ; zoom on ; 
	axis equal ; axis( [0 5 0 5] );  % [xmin xmax ymin ymax]
%	-------------------------------  dati ------------------------------ 	
	xC =  0.5 ;  yC = 0.5 ;  r = 3 ;  % tutto in metri
	m =  0.01 ;  	%  unit: kg
	g  =  9.81 ;  	%  unit:  m/s/s
	dt = 0.01; 		%  unit:  s
	fs  =  6 ;  		%  unit: cm/N
	th0 = 0.02; 	%  unit: rad Partenza poco discosta dalla sommit
	v0 = 0 ;  		%  unit: m/s
% 	-------------- traccia il vincolo circolare --------------
 	S = 0 : 0.04 : pi/2 ;   X = xC+r*cos(S) ;   Y = yC+r*sin(S) ; 
	fill(X,Y,'y','edgecolor','y') ; % riempie solo una lunula
%	completa il quarto di cerchio  riempiendo un triangolo 
	U=[xC+0.02,  xC+r,  xC+0.02,  xC+0.02] ; V=[yC , yC,  yC+r,  yC];
	fill(U,V,'y','edgecolor','y') ;  % (lo 0.02 e' un ritocco)
	pause
% 	--------- PRIMA FASE:-Il grave scivola sulla guida circolare----
%	Integrazione con il metodo di Eulero.	
% 	Valori iniziali: tempo, angolo e velocit angolare
	t = 0 ; th = th0 ;  om = v0/r ; 
	reaz = -1 ; 	% valore negativo fasullo per poter entrare nel ciclo while	
	rr=r+ 0.06; 	% piccolo ritocco per disegnare la pallina che "tocca" la guida
	b = 0; 	   	% contatatore per tracciare i fotogrammi
 
 	while reaz <=  0 
		x = xC+rr*sin(th) ; 	y = yC+rr*cos(th) ; 
   		if  mod(b,6) == 0  % traccia la pallina ogni 6 intervalli di integrazione
			f_circo(x,y,0.05,'k')
 		end
		% calcola e traccia la reazione (la normale  entrante)
		reaz = m*v0*v0 / r+2*m*g*(2-3*cos(th) );   % esterno:  negativa
		xx = xC+(r-reaz*fs)*sin(th) ; yy = yC+(r-reaz*fs)*cos(th) ;
		% escludi  l'ultimo fotogramma per il quale reaz > 0
		% e traccia la pallina ogni 6 intervalli di integrazione
 		if reaz <=0  &  mod(b,6) == 0
 			plot([x , xx], [y , yy],'linewidth',0.5,'color','k','era','back' );
			pause
 		end
		% metodo di integrazione di Eulero
		th1 = th+om*dt ;   om1 = om+g/r*sin(th) *dt ; 
 		om = om1 ; 	th = th1 ;  t = t+dt ; 
		b = b+1;
	end ; 
% 	-------------------------SECONDA FASE-: caduta libera----------------------
% 	Condiz. finali fase preced. = condiz iniz. fase seguente		
	t0 = t ; x0 = x ; y0 = y ; v0 = om*r;  
	vx0 = v0*cos(th) ;  vy0 =- v0*sin(th);  	
  	while  y>yC
 		t = t + dt;
 		x = x0 + vx0*(t-t0) ;    y = y0 + vy0*(t-t0) - g/2*(t-t0)^2 ; 
   		if  mod(b,6) == 0 ; f_circo(x,y,0.05,'k');  end
		b = b+1;
 	end
% 	----------------------------------------------------------------------fine--------------






