% Programma SCODELLA
%
% Questo programma disegna una scodella con un asta al suo  interno e fa vedere che la
%  posizione di equilibrio  quella  in cui il baricentro assume la posizione piu bassa possibile.
%	--------------------- MODALITA' GRAFICHE --------------------------------- 
	close all ; h1 = figure(1); 	
 	set(h1, 'Units', 'normalized', 'Position', [0 0  1  0.96]);
 %	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]);
 	hold on ; axis on ; zoom on ; pause on
 	whitebg(h1, 'black')
% 	colore di fondo
       	hold on;  % tiene il disegno precedente
 	axis([0   35   0   30])   
 	axis equal 	% immagine isometrica
 	h2=title('ASTA NELLA SCODELLA')
	set(h2,'fontsize',18,'color','w')
	xlabel('cm') ; ylabel('cm')
% ----------------------- DATI DEL PROBLEMA----------------------------------------------

	xC = 15;   yC =15;  % coordinate del centro della scodella (semicirconferenza)
	p = 15;   	% peso dell'asta (N) (non serve)
	r = 10;   	% raggio della scodella (cm)
	L = 2*r;  % lunghezza dell'asta (cm)
	f = 0.5;	% fattore scala forze
%	---------------------------SCODELLA----------------------------------------
% 	La scodella ha la forma di una semi-circonferenza. "alfa" = angolo di un raggio
%      generico con l'asse "x": esso  varia da "pigreco" a "2 pigreco" a passo "pigreco/100" 
	Ag = 180: 1: 360;   % array con i valori dell'angolo "A" in gradi 
	Ar = Ag*pi/180;   % array con i valori dell'angolo "A" in radianti 
% 	Equazione parametrica della "circonferenza" con due array
	X = xC+ r*cos(Ar);  Y = yC+ r*sin(Ar);   %  array
 	plot(X,Y,'w','linewidth',2);
% -------------------ASTA NELLA SCODELLA -----------------------------------

% traccia le posizioni da 60 gradi a zero
	for th_gradi = 60 : -2 : 3; 
		th = th_gradi*pi/180;	
		% estremo "A" dell'asta (sulla circonferenza)
		xA = xC - r*cos(2*th);  yA = yC - r*sin(2*th);    
		xB = xA + L*cos(th);  yB = yA + L*sin(th);
		% disegna l'asta;
		M=[xA   xB] ; N= [yA  yB];
		plot([xA   xB] , [yA  yB],'y','era','back','linewidth',1);
% 		h1=line([xA   xB] , [yA  yB]); 
 %		set(h1,'color','b','linewidth',1,'era','back');
      		xG = (xA+xB)/2;   	yG = (yA+yB)/2;
		% disegna il baricentro G dell'asta  
		plot(xG,yG,'     +','color','g','linewidth',1,'era','back');
		pause;  		
     	end  % fine ciclo
%-----------------------  POSIZIONE EQUILIBRIO ------------------------

% La posizione di equilibrio e' quella nella quale l'ordinata
% del baricentro G e' minima.  Posto
	s = (L+sqrt(L*L+128*r*r)) / (16*r); 	
	% si ha  "cos(tequil)=s", quindi 
	theq = acos(s); % arcocoseno
	xA = xC - r*cos(2*theq);  yA = yC - r*sin(2*theq);    
	xB = xA + L*cos(theq);  yB = yA + L*sin(theq);    
	pause;  plot([xA   xB] , [yA  yB] ,'color','w','linewidth',2,'era','back');
	xG = (xA+xB)/2;   	yG = (yA+yB)/2; % coordinate del baricentro
	% disegna il baricentro dell'asta
	plot(xG,yG,'.','color','w','linewidth',3,'era','back');
%--------- INTERSEZIONE LINEE D'AZIONE DELLE FORZE --------------

% 	indico con "S" un punto del segmento "AC" distante 24 cm da "A"
	xS= xA+24*cos(2*theq);  yS= yA+24*sin(2*theq); 	
	pause; plot([xA   xS] , [yA  yS],'color','c','linewidth',0.5,'era','back');
%	 -------------
%  	indico con"E" il bordo destro scodella
	xE =  xC+r;  yE= yC; 
% 	indico con "U" un punto del segmento passante per per "E"
%	ortogonale all'asta e distante 13 cm da "E"
	xU= xE+13*cos(theq + pi/2);  yU= yE+13*sin(theq + pi/2); 	
%	 disegna la direzione della reazione in "E"
	pause;  plot([xE   xU] , [yE  yU] ,'color','c','linewidth',0.5,'era','back');
%	-------------
% 	coordinate del baricentro G dell'asta
	xG = (xA+xB)/2; 	yG = (yA+yB)/2;    
% 	indico con "V" un punto sulla verticale per G e distante 16 cm da G
	xV=xG;  yV=yG+16;
	pause; plot([xG   xV] , [yG  yV] ,'color','c','linewidth',0.5,'era','back');
% ------------------- REAZIONI -------------------------------------------------------

% reazioni vincolari   
 	reazA = p*tan(theq);                          
 	reazE = - reazA*sin(theq) +p*cos(theq);
% reazione vincolarein A 
	x1 = xA+f*reazA*cos(2*theq); y1 = yA+f*(reazA*sin(2*theq));
 	pause; plot([xA   x1] , [yA  y1],'color','r','linewidth',2,'era','back');
% reazione vincolare in E	
	x2 = xE-f*reazE*sin(theq);   y2 = yE+f *(reazE*cos(theq));
	pause; plot([xE   x2] , [yE  y2] ,'color','r','linewidth',2,'era','back');
% peso (estremi della forza)
	x3 = xG; y3 = yG-f *p;
	pause; plot ([xG   x3] , [yG  y3],'color','g','linewidth',2,'era','back');
%-------------  fine -------------------

 
