%	-------------------------------------------------------------------------------
%				 TAGLIO
%	-------------------------------------------------------------------------------
%	Diagramma dell'azione di taglio su un'asta orizzontale soggetta 
%	a carichi verticali sia concentrati che distribuiti.
%	---->  chiama "f_vettoreY"
%	----------modalit grafica--------------
	close ; h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	hold on ; axis on  ;  grid off ; zoom on ;
	axis equal ; axis([0  16  -5  5]);
%	-------------- dati ---------------------------------
	xA = 2 ; 	yA = 0;	% estremo iniziale dell'asta
	xB = 12;  	yB= 0; 	% estremo finale dell'asta
	L = xB-xA; 		% lunghezza dell'asta
	q = 50 ;			% peso dell'asta (N)
	fs = 0.04; 			% fattore scala forze
	fss = 2; 			% fattore scala carichi distribuiti
	p = 0.1;			% passo per il diagramma
% 	Carichi concentrati: positivi se nel senso della normale
% 	Ff = array forze  verticali concentrate discendenti i (in newton)
 	Ff = 0; %  Ff= [50]  % Ff = [12  35 ]; 	 	
% 	Sf = array posizioni (in metri) delle forze  concentrate
 	Sf=[0.4*L]  % Sf = [0.4*L   0.6*L]; 		
	nf = size(Ff,2) ; 
% 	Carico uniforme distribuito: lo consideriamo come un carico discreto
%	su un passo piccolo ottenuto dividendo "L" in "w" tronchi.
	w = 100;				% numero dei tronchi
	g = L/w;				%  g = lunghezza di ogni tronco
  	qw = q / w ; 			%  peso di ogni tronco 
	Fq =  qw * ones(1,w);  	%  array dei carichi  uniformi (N/m)
	Sq =  g/2 : g : L ;  		% array dei punti medi dei tronchi
% 	reazioni in A  e B
	risultante = sum(Ff) + sum(Fq); 	% somma delle forze
	momento = Ff * Sf' + Fq * Sq';	% somma dei momenti
	VB = momento / L ;  VA = risultante - VB ;   
%	-----------------------------------------------------------
 	for s = 0 : p : L
%		calcola la somma delle forze concentrate fino ad "s"
		Zf = Sf (Sf < s);  	% Z = array delle posizioni precedenti "s"
		zf = size(Zf,2);		% dimensioni dll'array
 		fn = 0;			% fn = somma delle forze concentrate 
		for k=1 : zf ;  fn = fn + Ff(k);   end ; 
%		aggiungi la somma delle forze distribuite fino ad "s"
		Zq = Sq (Sq < s);  	% U = array delle posizioni precedenti "s"
		zq = size(Zq,2);	% dimensioni dell'array
		for h=1 : zq ;  fn = fn + Fq(h);   end ; 
%		diagramma dell'azione di taglio "T"
		T = - VA + fn; 	% azione di taglio
		x = xA + s / L*(xB-xA); 	y = yA + s / L*(yB-yA); 
		x1 = x ;  			y1 = y +T*fs;  
		plot([x   x1] , [y  y1],'r','linewidth',0.5,'era','back')
	end
%	---------------------------------------------------------------
%	traccia asta 
	plot([xA  xB],[yA  yB],'k','linewidth',1,'era','back')
% 	traccia reazione in A
	reazA =  sign(VA) * VA* fs ;  	y0 = yA +reazA;  
	f_vettoreY(xA, yA, reazA, 'm', 2,     0.32, 0.20  ) ; 
% 	traccia reazione in B		
	reazB =  sign(VB) * VB* fs ;  	y0 = yB  +reazB;  
	f_vettoreY(xB, yB, reazB, 'm', 2,    0.32, 0.20  ) ; 
% 	traccia forze  concentrate	
	for k=1 : nf
		x = xA + Sf(k)  ; 	 y = yA   ; 
		forza =  -Ff(k)*fs ;  	yf = y  + forza;  
%		f_vettoreY(x, y, forza, 'b', 2,    0.32, 0.20  ) ; 
	end
% 	traccia forze  distribuite	
	for k=1 : 3: w
		x = xA + Sq(k)  ;  	y = yA  ; 
		xq = x ; 			yq = y + Fq(k)*fss;  	
% 		plot([x  , xq] , [y , yq] ,'b','linewidth',0.5,'era','back')
	end
%	----------------------------------------------------------- fine
