% 	chiamato da "forzatoBello"
	
	w0  = get(pulsnat, 'value');	% pulsazione naturale
	del = get(smorza, 'value');	% costante smorzamento
   wi  = get(pulsforz, 'value');	% pulsazione impressa
   
	z = wi/w0;		% numero puro: rapporto delle pulsazioni
	e = del/w0;		% numero puro: fattore di smorzamento
	A = 1;  			% ampiezza oscillazione libera
	a = 0; 			% fase oscillazione libera
   f0=3;   			% forza massima
   m=1;				% massa
   k=m*w0^2;		% rigidezza della molla
   x0=f0/k;			% elongazione statica
   t = 0 : 0.01 :10;	% tempo
%	------------------------------------------------------	
    	if del < w0  		%  sistema sottosmorzato
		w = sqrt(w0^2-del^2); 	% pulsazione del moto smorzato  
		arg=-(2*e*z)/(1-z*z);
		if z <= 1
			beta=atan(arg);
		else
			beta=atan(arg)-pi;
		end
		D=1/sqrt( (1-z*z)^2+(2*e*z)^2 );
      x = A*exp(-del*t).*sin(w0*t+a)+x0*D.*sin(wi*t+beta);
  		plot(t,x,'y','linewidth',1,'era','back');
 		line([0  10],[0   0],'color','r','era','back');	% asse orizzontale
%		axis([0  10   -150   150]);
 		hold off
    	end
%	------------------------------------------------------	
   if del > w0 		%  sistemi sovrasmorzati
		disp('sovrasmorzato')
		mu=sqrt(e^2-w0^2);
		A=(mu*x0-e*x0 -v0)/(2*mu);
		B=(mu*x0+e*x0 +v0)/(2*mu);
        	x = exp(-e*t).*(A*exp(-mu*t) +B*exp(mu*t));
 		plot(t,x,'c','linewidth',1,'era','back');
 		line([0  10],[0   0],'color','r');	% asse orizzontale
		axis([0  10   -8   8]);
 		hold off
  	end
%
	if del == w0 		%  smorzamento critico
		disp('smorzamento critico')
		A=x0;
		B=v0+e*x0;
     	x = (A+B*t).*exp(-e*t);
 		plot(t,x,'m','linewidth',1,'era','back');
 		line([0  10],[0   0],'color','r','era','back');	% asse orizzontale
		axis([0  10   -8   8]);
 		hold off
 	end
%
%	------------------------------------------------------
 
%	traduci i numeri in stringhe per poterli scrivere sul disegno
	ww0=num2str(w0);
	wwi=num2str(wi);
	ddel=num2str(del); 
%	scrivi i valori dei parametri nella finestra sotto
 	valorew0=uicontrol('style','text',...
		'Units','normalized',...
		'position',[0.02  0.02  0.08  0.04],...
	 	'fontname','times',...
      	'fontsize',10,...
   		'string',ww0);	
%	scrivi i valori dei parametri nella finestra sotto
 	valorewi=uicontrol('style','text',...
		'Units','normalized',...
		'position',[0.52  0.00  0.08  0.04],...
	 	'fontname','times',...
      	'fontsize',10,...
   		'string',ddel);	
%	scrivi i valori dei parametri nella finestra sotto
 	valoreeps=uicontrol('style','text',...
		'Units','normalized',...
		'position',[0.92  0.02  0.08  0.04],...
	 	'fontname','times',...
      	'fontsize',10,...
   		'string',wwi);	
	% 	  	'horizontalalignment','center',...

 	
