%=======================================================
%                          leggiElencoNomi2.m
% 			(basato su "personaggi2")
%	Legge l'archivio "tuttiPersonaggi.txt" 
%	che contiene personaggi in ordine di data di nascita
%	lo elabora
%	estrae i personaggi e li memorizza come  "cellArray"
%	scomponendoli in:  categoria,  nazione,  nome,  nascita,  morte
%	
%
%
%---------------------------------------------------------------
 	clear  	% elimina tutte le variabili in memoria
	clc   		% azzera la finestra dei comandi
% 	++++++++++++++++++++++++++++++++++++++++	
	AI=1500;	% annoiniziale
	AF=2000;	% annofinale
	delta=3;			% incremento verticale
	A='fis'    % 'fil' 'fis'
	B= 'aut'  %'ted'   'ita'  'fra'  'gre'  'svi'  'aut'
% 	++++++++++++++++++++++++++++++++++++++++	
 
% Il nome esterno del file   'tuttiPersonaggi.txt'
% Il nome deve essere posto entro apici perch e' una stringa.
% Si apre il file assegnandogli il nome interno "Bologna" 
% in lettura  ( 'r'  che sta per "read" ).
%  ... michela.txt  ....  ..tuttiPersonaggi.txt... provaLettura.txt
	Bologna = fopen ( 'tuttiPersonaggi.txt' , 'r');
% Si preleva dall'archivio "Bologna" la matrice "M"
% leggendo tutte le righe in formato carattere "%c"
	M = fscanf ( Bologna , '%c' ,  [1 inf] );
% Si noti che per primo si mette il nome interno: (Bologna)
% per secondo si mette il formato ('%c') 
% per terzo si mette il numero di elementi per riga "1" ?
% e, non sapendo quante righe sono, si mette "inf" 
% le due ultime entro parentesi quadre per indicare la matrice 
% Quindi si chiude il file
	fclose (Bologna);
% Il testo prelevato e'
%		M
% 	si tratta di un  grandissimo vettore che contiene tutti i codici
%	ASCII dei singoli caratteri
	maxM=size(M,2); %   9635 caratteri 
% 	Notare le corrispondenze 
%	apre:		fopen (...)			chiude: 	fclose (...)
%  	scrive:	fprintf (...)			legge:	fscanf (...)

%============================================
%					GRAFICA
%============================================
	close;  
	h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
 	whitebg('k'); 
	
	axis([AI  AF  0  100])
 	hold on ;   axis on ; grid on
%	-------------------------------------------------------
%	 traccia date salienti
%	-------------------------------------------------------
%     
       	line([1873  1873],[0  100 ],'color','r')  % Maxwell treatise
	
% 	text(1600,135,'personaggi dell''elettromagnetismo',...
% 	'fontsize',14,'fontweight','bold')
%  	text(1867,-25,'1873')
%   	line([1873  1873],[-20  50 ],'color','w','linestyle','--') 
 	title('personaggi.m');	
%	-------------------------------------------------------
% 	codici di interesse:
% 	spazio 		32
% 	a capo 		13  DEVI METTERE 13 NON 10 !!!
% 	quadratello   	7
% 	punto 		46
% 	virgola: 		44
% 	tabulazione	10 ???
% ---------------------------------------------------------------------------------
% dividi in:  categoria,  nazione,  nome,  nascita,  morte
% ---------------------------------------------------------------------------------
% esamina il vettorone M per scomporlo. individuando gli "a capo" e la "virgola"
%	------------------------	
% 	categoria
%	------------------------	
	N=1; % numeratore della stringa 
	k=1; 	% numeratore del carattere nell'interno di M
	while k<= (maxM )	%  perche'  -2 ?
		q='';
		n=1;
		while abs(M(k)) ~= 44   % virgola  
			q(n)= M(k); 
			n=n+1;
			k=k+1; 
		end
 		R{N,1}=q; 
 		k=k+1;
%	------------------------	
%	nazione
%	------------------------	
 		s='';
		n=1;
		while abs(M(k)) ~= 44   
			s(n)= M(k);
			n=n+1;
			k=k+1;
		end
 		R{N,2}=s; 
 		k=k+1;

%	------------------------
%	nome
%	------------------------	
		u='';
		n=1;
		while abs(M(k)) ~= 44  
			u(n)=  M(k); 
			n=n+1;
			k=k+1;
		end
 		R{N,3}=u; 
 		k=k+1;
%	------------------------
% 	data nascita
%	------------------------	
		z='';
		n=1;
		while abs(M(k)) ~= 44     
			z(n)=M(k); 
			n=n+1;
			k=k+1;
		end
 		R{N,4}=z; 
  		k =k+1;
%	------------------------
% 	data morte
%	------------------------	
		y='';
		n=1;
		while   abs(M(k)) ~= 13      
			y(n)=  M(k); 
			n=n+1;
			k=k+1;
		end
 		R{N,5}=y; 
  %	------------------------	
 		k =k+1;
 		N=N+1;
	end % while
	Nmax=N-1;	
  
%============================================
% 					SELEZIONA
%============================================
	quota=2;
   	for N=1:Nmax
	   	if R{N,1} == A      %   &   R{N,2} == B
%			C=[R{N,1} ','  R{N,2} ','  R{N,3} ','  R{N,4} ','  R{N,5}];
%	   		fprintf('%s  \n' ,C  )
%			disp(C)
			S=R{N,3};			% nome
			Sn=str2num(R{N,4}); 	% nato
			Sm=str2num(R{N,5});  	% morto
%			scrivi i nomi
     			line([Sn  Sm],[quota  quota],'linewidth',2,'color','y') ;
 			text(Sn, quota+1, S, 'fontsize',10,'color','c','fontweight','normal');
			quota=quota+delta;
		end
	end
% 	 ------------------------------------------------------------------------
  
