		function [ermax]= f_Cauchy(h, N); 
%  -----------------------------------------------------------------
%     Integrazione dell'equazione dei moti armonici
%         con il metodo di Heun = Eulero-Cauchy 
	global   m  k  c  A  D  w
%  -----------------------------------------------------------------
%  valuta la derivata all'inizio e alla fine quindi prende la media
%	x'(t)=p/m 		x(t+h)=x(t)+ (p(t)/m)*h	
%	p'(t)=-k*x		p(t+h)=p(t)+(-k*x(t))*h
%  					x(t+h) =x(t)+[p(t)/m+p(t+h)/m]/2*h	
%					p(t+h)=p(t)+[-k*x(t)-k*x(t+h)]/2*h
% 
%   costruisci i vettori X e P 
	T(1) = 0;			%	istante iniziale
   	X(1) = 0;			%   posizione iniziale
 	P(1) = m*A*w;  	%   quantit di moto iniziale
	E(1) = X(1);		%	esatto
	ermax = 0;

  	for n = 1 : N-1
%		incremento con la derivata nel punto iniziale
 		[Dx1,Dp1] = f_armonico (h,T(n), X(n), P(n));    		
%		incremento con la derivata nel punto finale
 		[Dx2,Dp2] = f_armonico (h,T(n)+h, X(n)+Dx1, P(n)+Dp1);    		
%	 	media	
    		Dx  = (Dx1+Dx2)/2;
  		Dp  = (Dp1+Dp2)/2;
		
		T(n+1) = T(n) + h;	
   		X(n+1) = X(n) + Dx;
   		P(n+1)  = P(n) + Dp; 
% 		E(n+1) = A * exp(-D*T(n+1)) * sin(w*T(n+1));		%	esatto
% %		valuta l'errore massimo
% 		scarto = abs(X(n+1)-E(n+1));
% 		if scarto > ermax    
% 			 ermax = scarto; 
% 		end
	end
% si suppone che il massimo errore sia alla fine dell'intervallo
	ermax=X(N) - A * exp(-D*T(N)) * sin(w*T(N));	
%	-------------------- fine ------------------	
