	function  [G2 , traccia]= f_MatAff(x,y,u,v,i,j,k);
% 	(chiamata   da "SP3.m", da "generaAffine.m")
%	------------------------------------------------------------------------80------
% 	Calcola la matrice che descrive uno spostamento affine.
%	i, j, k 	=	i tre vertici del triangolo
%		x,y	= 	vettore delle ascisse e ordinate dei tre vertici i,j,k
%		u,v	= 	vettore delle componenti orizzontali e verticali 
%				degli spostamenti nei  tre vertici i,j,k
% 
% 	Sia dato un campo vettoriale piano affine
%		u  =  a + Gxx*x + Gxy*y
%		v  =  b + Gyx*x + Gyy*y
% 	dobbiamo calcolare le sei costanti "a, b, Gxx, Gxy, Gyx, Gyy"
% 	Scriviamo le componenti "u" nei tre vertici 
%		u(i)  =  a + Gxx*x(i) + Gxy*y(i)
% 		u(j)  =  a + Gxx*x(j) + Gxy*y(j)
% 		u(k)  =  a + Gxx*x(k) + Gxy*y(k)
% 	Eliminiamo "a" (che non interessa) facendo una combinazione
% 	lineare delle equazioni. Si tratta di risolvere
% 		[x(j)-x(i)] * Gxx + [y(j)-y(i)] * Gxy  =  u(j)-u(i)
% 		[x(k)-x(i)] * Gxx +[y(k)-y(i)] * Gxy  =  u(k)-u(i)
% 	La matrice dei coefficienti e'
 	A2 = [	x(j)-x(i) y(j)-y(i);  
			x(k)-x(i) y(k)-y(i)	];
% 	(primo) vettore dei termini noti
	bx = [u(j)-u(i);  u(k)-u(i)]; % vettore colonna
% 	Creiamo un vettore Gx a due componenti tale che :
% 	Gxx = Gx(1)   Gxy = Gx(2). La soluzione e'
	Gx =  A2\bx;
%	----------------------------------------	
% 	Operiamo in modo analogo  per determinare Gyx e Gyy
  	by = [v(j)-v(i);  v(k)-v(i)]; % vettore colonna
	Gy =  A2\by;
%	----------------------------------------	
%	in conclusione il gradiente dello spostamento e'	
% 	la matrice G2 data da
	G2 = [Gx(1) Gx(2);
		  Gy(1) Gy(2) ];
%	 calcola invariante lineare
	 traccia =  Gx(1) +  Gy(2); 
%	 z=eig(G2);
%	 t=z(1)+z(2)
%------------------------------------------------------------------- fine------
