 		function [ermax]= f_Runge(h, N); 
%  -----------------------------------------------------------------
%     Integrazione dell'equazione dei moti armonici
%         con il metodo di Runge-Kutta IV
	global   m  k  c  A  D  w
%  -----------------------------------------------------------------
%  Dx1 = Dt f(T(n), X(n)) 
%  Dx2 = Dt f(T(n)+Dt /2, X(n)+Dx1 /2)
%  Dx3 = Dt f(T(n)+Dt /2, X(n)+Dx2 /2)  
%  Dx4 = Dt f(T(n)+Dt,  X(n)+Dx3)
%  X(n+1)=X(n)+(Dx1+2*Dx2+2* Dx3+Dx4)/6
%	e analoghe per la P
	T(1) = 0;			%	istante iniziale
   	X(1) = 0;			%   posizione iniziale
 	P(1) = m*A*w;  	%   quantit di moto iniziale
	E(1) = X(1);		%	esatto
	ermax = 0;
	 	
 	for n = 1 : N-1
%		incremento con la derivata nel punto INIZIALE
 		[Dx1,Dp1] = f_armonico (h, T(n), X(n), P(n));
%		incremento con la derivata nel punto medio
  		[Dx2,Dp2] = f_armonico (h, T(n)+h/2, X(n)+Dx1/2, P(n)+Dp1/2);
%		incremento con la derivata nel punto medio
  		[Dx3,Dp3] = f_armonico (h, T(n)+h/2, X(n)+Dx2/2, P(n)+Dp2/2);
%		incremento con la derivata nel punto FINALE
  		[Dx4,Dp4] = f_armonico (h, T(n)+h, X(n)+Dx3, P(n)+Dp3);
%		media pesata degli incrementi
   		Dx  = (Dx1+2*Dx2+2*Dx3+Dx4)/6;
		Dp  = (Dp1+2*Dp2+2*Dp3+Dp4)/6	;
		
		T(n+1) = T(n) + h;	
  		X(n+1) = X(n) + Dx;
		P(n+1)  = P(n) + Dp; 
% 		E(n+1) = A * exp(-D*T(n+1)) * sin(w*T(n+1));		%	esatto
% %		valuta l'errore massimo
% 		scarto = abs(X(n+1)-E(n+1));
% 		if scarto > ermax    
% 			 ermax = scarto; 
% 		end
	end
	ermax=X(N) - A * exp(-D*T(N)) * sin(w*T(N));	
%	-------------------- fine ------------------	

	
	 
