% 
% PROGRAMMA spiega (illustrazione metodo delle celle)
%
%	-------------------------------------------------------------- 
% funzione: f_bez3D			creato: 13/09/1998		modificato: 
%	-------------------------------------------------------------- 
%
% parti del file:	definizione procedura;
%						tracciamento curva di Bezier in 3D.
%
%	-------------------------------------------------------------- 
%	-------------------------------------------------------------- 
% 	viene chiamata da: f_08a
% 	           chiama: <>
%	-------------------------------------------------------------- 
%	-------------------------------------------------------------- 
% tracciamento curva di Bezier in 3D
% ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%
%
% =====definizione procedura=====
%
	% definizione funzione
	function f_bez3D(fs,xT,yT,pc,Bx,By,Bz1,Bz2,colore)
   % dichiarazione variabili globali
   global MCV MVT MNV f12a f14a  f18a  f25a csp rMCV  rMVT
   global np numpag aa pbspi1 pbspi2 espi1 stpi1
%
% =====tracciamento curva di Bezier in 3D=====
%
	% trasformazione coordinate punti
	Bx = Bx*fs+xT;		By = By*fs+yT;
	% valore iniziale ascissa curvilinea (valori tra 0 e 1)
   a2 = 0;
   hold on
	% memorizzazione punti curva
	for a1=1:(pc+1)
   	% coordinate punti della curva
   	xx(a1) = ((1-a2)^3)*Bx(1)+3*a2*((1-a2)^3)*Bx(2)+3*(a2^2)*(1-a2)*Bx(3)+(a2^3)*Bx(4);
      yy(a1) = ((1-a2)^3)*By(1)+3*a2*((1-a2)^3)*By(2)+3*(a2^2)*(1-a2)*By(3)+(a2^3)*By(4);
   	% aggiornamento valore ascissa curvilinea
   	a2 = a1/pc;
   end % del for a1=1:(pc+1)
   %
   % caso della copertura del solido
   if Bz1==Bz2
   	% ciclo tracciamento
   	for a1=1:pc/2
      	% preparazione vettori tracciamento
      	Vx = [xx(a1) xx(a1+1) xx(pc+1-a1) xx(pc+2-a1)];
      	Vy = [yy(a1) yy(a1+1) yy(pc+1-a1) yy(pc+2-a1)];
      	Vz = [Bz1 Bz1 Bz2 Bz2];
      	% riempimento zona tra le due curve
      	fill3(Vx,Vy,Vz,colore);
   	end % del for a1=1:pc
   else
   	% ciclo tracciamento
   	for a1=1:pc
      	% preparazione vettori tracciamento
      	Vx = [xx(a1) xx(a1+1) xx(a1+1) xx(a1)];
      	Vy = [yy(a1) yy(a1+1) yy(a1+1) yy(a1)];
      	Vz = [Bz1 Bz1 Bz2 Bz2];
      	% riempimento zona tra le due curve
      	fill3(Vx,Vy,Vz,colore);
      end % del for a1=1:pc
   end
   
   
