%---------------------------------------------------60-------
 	function [N5, L4, n] = f_cerchio1(L,k,N5, L4,xc,yc,R,s);
%------------------------------------------------------------
% Costruisce un poligono regolare per "easymesh"
% di centro "xc, yc",  
% di raggio circoscritto "R" e di lato "L"
% di orientazione antioraria (s=1) oppure oraria (s=-1)
% 	N5 = matrice dei vertici
% 	B4 = matrice dei lati
%	n =  numero dei vertici e dei lati
% Devo costruire una matrice dei vertici "N5" che ha:
% 	in prima colonna il numero del vertice
% 	in seconda colonna l'ascissa del vertice
% 	in terza colonna l'ordinata del vertice
% 	in quarta colonna la dimensione dei lati dei triangoli
% 	in quinta colonna un marker a disposizione 
%	(noi lo porremo = 1 per tutti)
%
	n = round(2*pi*R/L) ; 
	a = 2*pi/n; 	% angolo
	a = a * s; 		% s = -1 per fare la numerazione oraria
% Crea il poligono di "n" vertici.
% e quindi assegnare i valori delle componenti
% Per "easymesh" la numerazione parte da zero
	ki=k;	
	for h=1:n
		% matrice dei nodi 
		N5(k , 1) = (k-1); % <----- partenza da zero
		N5(k , 2) = xc+R*cos(h*a-a); % ascissa vertice
		N5(k , 3) = yc+R*sin(h*a-a);	% ordinata vertice
		N5(k , 4) = L;	% dimensione dei lati dei triangoli
		N5(k , 5) = 1;	% marker = 1 per tutti
		% matrice dei lati	
 		L4(k , 1) = N5(k , 1);
		L4(k , 2) = N5(k , 1);
		L4(k , 3) = N5(k , 1)+1;
		L4(k , 4) = 1;
		if h==n
			L4(k , 3) = N5(ki , 1);
		end
		k=k+1;
	end
	kf=k-1; 
	n=kf 
	% lato di chiusura
	plot( N5(ki:kf,2) , N5(ki:kf,3) , 'color','y','era','back');
 	line([N5(kf,2) N5(ki,2)], [N5(kf,3) N5(ki,3)] , 'color','y','era','back');
%---------------------------------------- fine --------------
 
