% -----------------------------------------------
% 		 f_circ.m
% -----------------------------------------------
%	richiamato da "interpola_circolazione.m"
	function  [ee]=f_circ(x1,y1,x2,y2)
	
%	dichiarazione di variabili simboliche (senza virgole)
	Syms  g  h  u1  u2  v1  v2  uu   vv  x  y   s  t  f    
%	Dato un campo vettoriale di componenti  u(x,y), v(x,y)
%	e dato un segmento 1-2
% 	si vuole calcolare la circolazione del vettore lungo il segmento.
 %	Il segmento ha come equazione parametrica
   	x=x1+t*(x2-x1); 	 y=y1+t*(y2-y1);
%	di  fatto viene: x=3*t  y=2*t con t compreso tra 0 ed 1.
%	Le funzioni sono:
%	>>>>>>>>>>>>>>>>>>>
%	u=x+y   v=x-y
%	<<<<<<<<<<<<<<<<<<<<
% 	spacco le funzioni in due pezzi
   	u1=x;  	s=compose(u1,'x','t');	
 	u2=y; 	t=compose(u2,'y','t');
 	uu=s+t;
%
   	v1=x;  	g=compose(v1,'x','t');	
 	v2=y; 	h=compose(v2,'y','t');
 	vv=g-h;
%	Le funzioni uu, vv sono diventate funzioni di t 
%	---------------------------------------
   	f = uu*(x2-x1)+vv*(y2-y1);
	e=int(f,0,1);
	ee=eval(e);
 
 
%	--------------------- OK
%   	compose(1/(1+x^2),sin(x))  % funziona
%	--->  1/(1+sin(x)^2)
%	--------------------- OK
%	u=1/(1+x^2); v=sin(x);
%	compose(u,v)
%	--->  1/(1+sin(x)^2)
%	--------------------- OK

