%============================
% 			circoce
%============================
 
% Asseganto un triangolo di vertici "h,i,j" si determina il circocentro Q
% facendo uso delle coordinate cartesiane. Si determinano successivamente 
% le coordinate affini del circocentro.
%-------------------------------------------------
% TEORIA
%-------------------------------------------------
% E' opportuno prendere il vertice "h" come riferimento
% e orientare id ue assi da h ad i e da h a j
% asse segmento (h,i)
% x=(x_h+x_i)/2-m(y_i-y_h)  
% y=(y_h+y_i)/2+m(x_i-x_h)
% asse segmento (h,j)
% x=(x_h+x_j)/2-n(y_j-y_h)   
% y=(y_h+y_j)/2+n(x_j-x_h)
% intersezione
% (x_h+x_i)/2-m(y_i-y_h)=(x_h+x_j)/2-n(y_j-y_h)
% (y_h+y_i)/2+m(x_i-x_h)=(y_h+y_j)/2+n(x_j-x_h)
% sistema 
% -(y_i-y_h)m+(y_j-y_h)n=(x_j-x_i)/2
%  (x_i-x_h)m-(x_j-x_h)n=(y_j-y_i)/2
% soluzione
%  N=-(x_j-x_i)(x_j-x_h)-(y_j-y_i)(y_j-y_h)
%  D=(y_i-y_h)(x_j-x_h)-(y_j-y_h)(x_i-x_h)
% D = area del triangolo "h,i,j"
%  m =  N / (2*D);
% si veda l'appendice del "metodo-celle" 
 %	-------------------------------------------------------------- 
%			seleziona modalita' grafica 
%	-------------------------------------------------------------- 
% 	chiudi finestre grafiche precedenti	
	close all		
% 	apre una finestra grafica di dimensioni volute
	h1 = figure(1); 	
 %	set(h1, 'Units', 'normalized', 'Position', [0.5 0.5 0.45 0.5]);
	set(h1, 'Units', 'normalized', 'Position', [0 0  1  0.96]);
% 	colore di fondo
  	whitebg(h1, 'black')
% 	colore della cornice (deve precedere axis)
%  	set (gcf,'Color',[0.90	0.60	0.30]) % dopo "whitebg"
%	assi di dimensioni volute
 	axis([0 18 -2 14] );  % [xmin xmax ymin ymax]
%	"hold on" consente piu' tracciamenti sulla stessa finestra
	hold on
%	zoom on
	axis equal
	arancione=[1.00 	0.40 	1.00];
	rossochiaro= [0.5 		0.00 	0.00];
	rame 	= [1.00 	0.62	0.40];

 %-------------------------------------------------

% assegna le coordinate cartesiane del triangolo
	x_h=0;  	y_h=0;
 	x_i=16;  	y_i=0;
 	x_j=10;  	y_j=12;

% circocentro Q
	N =-(x_j-x_i)*(x_j-x_h)-(y_j-y_i)*(y_j-y_h);	
	D = (y_i-y_h)*(x_j-x_h)-(y_j-y_h)*(x_i-x_h);	
	mQ =  N/(2*D);	
	xQ=(x_i+x_h)/2-mQ*(y_i-y_h);
	yQ=(y_i+y_h)/2+mQ*(x_i-x_h);
 
	line([x_h  x_i] , [y_h  y_i],'linewidth',1,'color','g');
 	line([x_h  x_j] , [y_h   y_j],'linewidth',1,'color','g');
 	line([x_i  x_j] , [ y_i  y_j],'linewidth',1,'color','g');

	plot(xQ,yQ,'r*');
	
 
	x1=(x_i+x_h)/2;	y1=(y_i+y_h)/2;
	x2=(x_i+x_j)/2;	y2=(y_i+y_j)/2;
	x3=(x_j+x_h)/2;	y3=(y_j+y_h)/2;
	line([x1  xQ] , [y1  yQ],'linewidth',2,'color',rame);
 	line([x2  xQ] , [y2   yQ],'linewidth',2,'color',rame);
 	line([x3  xQ] , [ y3  yQ],'linewidth',2,'color',rame);
 
% coordinate affini del circocentro
 %    	cartesianeAffini(xQ,yQ,x_h,y_h,x_i,y_i,x_j,y_j);    
%	cartesianeAffini(x_h,y_h,x_h,y_h,x_i,y_i,x_j,y_j);   
%	cartesianeAffini(x_i,y_i,x_h,y_h,x_i,y_i,x_j,y_j);    
%	cartesianeAffini(x_j,y_j,x_h,y_h,x_i,y_i,x_j,y_j); 
% punti medi
%	cartesianeAffini(x1,y1,x_h,y_h,x_i,y_i,x_j,y_j); 
%	cartesianeAffini(x2,y2,x_h,y_h,x_i,y_i,x_j,y_j); 
%	cartesianeAffini(x3,y3,x_h,y_h,x_i,y_i,x_j,y_j); 
	
	
	
