	function [M]=f_circocentro(P,Q,R,X);
%	-----------------------------------------------
%		circocentro di PQR
%	-----------------------------------------------
% 	equazione di un piano 
% 	s1*x + s2*y +s3*z = 1    
% 	passante per P, Q, R: s1, s2, s3 sono da determinare
%  	si ottiene il sistema
% 	s1*P(1) + s2*P(2) + s3*P(3) = 1 
%  	s1*Q(1) + s2*Q(2) +s3*Q(3) = 1 
%  	s1*R(1) + s2*R(2) +s3*R(3) = 1 
%  	ricaviamo la matrice 
	F=[	 P(1)      P(2)     P(3)
		 Q(1)      Q(2)     Q(3)
		 R(1)      R(2)     R(3)]
	det(F)
% 	ed il vettore dei termini noti
	G=[1; 1; 1];
% 	ricaviamo:	  
	S=F\G;
	s1=S(1); s2=S(2); s3=S(3) ; % comoda nel seguito
%	-----------------------------------------------
%	Retta passante per lo sferocentro e ortogonale alla faccia PQR 
%	r  = rQ+ lambda (PQ prodotto vettoriale PR)
%	x = xQ+lambda * p
%	y = yQ+lambda * q
%	z = zQ+lambda *  r
% 	essendo p,q,r i minori del determinante che da' il prodotto vettoriale
	pp=[	(Q(2)-P(2))   (Q(3)-P(3))  
		(R(2)-P(2))   (R(3)-P(3))];
	qq=[	(Q(3)-P(3))   (Q(1)-P(1)) 
		(R(3)-P(3))   (R(1)-P(1))];
	rr=[ (Q(1)-P(1))   (Q(2)-P(2)) 
		(R(1)-P(1))   (R(2)-P(2))];
	p = det(pp);   q = det(qq);   r = det(rr); 
% 	s1*(xQ+lambda* p)  + s2*(yQ+lambda* q) +s3*(zQ+lambda* r) = 1    
% 	donde 
% 	(s1*xQ+ s2*yQ+s3*zQ) +lambda*( s1*p+s2* q+s3*r)  = 1   
% 	ovvero
	lambda=(1-(s1*X(1)+ s2*X(2)+s3*X(3)))/( s1*p+s2* q+s3*r);
% 	donde
 	M(1)=X(1)+lambda* p;
 	M(2)=X(2)+lambda* q;
 	M(3)=X(3)+lambda* r;
%	-----------------------------------------------
