% 
% PROGRAMMA spiega (illustrazione metodo delle celle)
%
%	-------------------------------------------------------------- 
% funzione: f_duabar			creato: 10/07/1998		modificato: 28/08/1998
%	-------------------------------------------------------------- 
%
% parti del file:	definizione procedura;
%						calcolo baricentro;
%						calcolo punti medi dei lati;
%						tracciamento lati baricentrici.
%
%	-------------------------------------------------------------- 
%	-------------------------------------------------------------- 
% 	viene chiamata da: f_20, f_25, f_26, f_31, f_32
% 	           chiama: <>
%	-------------------------------------------------------------- 
%	-------------------------------------------------------------- 
% tracciamento segmenti dal baricentro ai punti medi dei lati
% ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
%
%
% =====definizione procedura=====
%
	% definizione funzione
	function f_duabar(colore,fs,xT,yT,a1)
   % dichiarazione variabili globali
   global MCV MVT MNV f12a f14a  f18a  f25a csp rMCV  rMVT
   global np numpag aa pbspi1 pbspi2 espi1 stpi1
%
% =====calcolo baricentro=====
%
	% numero vertici del triangolo <a1>
   h = MVT(a1,1); 	i = MVT(a1,2); 	j = MVT(a1,3); 
   % coordinate vertice h
   xh = MCV(h,1)*fs+xT;		yh = MCV(h,2)*fs+yT;
   % coordinate vertice i
   xi = MCV(i,1)*fs+xT;		yi = MCV(i,2)*fs+yT;
   % coordinate vertice j
   xj = MCV(j,1)*fs+xT;		yj = MCV(j,2)*fs+yT;
   % ascissa baricentro
   xG = (xh+xi+xj)/3;
   % ordinata baricentro
   yG = (yh+yi+yj)/3;
%
% =====calcolo punti medi dei lati=====
%
	% coordinate punto medio lato per h-i
	Px = (xh+xi)/2;		Py = (yh+yi)/2;
	% coordinate punto medio lato per h-j
	Qx = (xh+xj)/2;		Qy = (yh+yj)/2;
	% coordinate punto medio lato per i-j
   Rx = (xi+xj)/2;		Ry = (yi+yj)/2;
%
% =====tracciamento lati baricentrici=====
%
	% tracciamento linee baricentro-centro dei lati
	m(1)=line([xG   Px],[yG   Py], 'era','back');
	m(2)=line([xG   Qx],[yG   Qy], 'era','back');
   m(3)=line([xG   Rx],[yG   Ry], 'era','back');
   % settaggio linea tracciamento
	set(m,'linewidth',2,'color',colore);
