		function [ermax]= f_Naturale(h, N); 
%  -----------------------------------------------------------------      				
%     Integrazione dell'equazione dei moti armonici
%         con il metodo naturale 
	global   m  k  c  A  D  w
%  -----------------------------------------------------------------
%	s 	= 1 + c*dt/(2*m);
%	ss	= 1 -  c*dt/(2*m);
%
%	       t(n) = t(n-1)+dt
% 	      x(n) = x(n-1) + dt * velocita(t(n - 1), x(n - 1), p(n)) 
% 	p(n + 1) = ( p(n) *ss   + dt * p(n)/m) /s
% 	dal momento che MATLAB numera le componenti da uno anziche' da zero
% 	aumentiamo l'indice di uno:
%	T(n+1) = T(n)     + h
%	X(n+1) = X(n)    + h * P(n+1) / m   
%	P(n+2) = ( P(n+1)*ss - h*k*X(n+1) )/s
%  X e' calcolato agli istanti del primale, P a quelli del duale 
 	T(1) = 0;			%	istante iniziale
 	X(1) = 0;			%   posizione iniziale
 	P(2) = m*A*w;  	%   quantit di moto iniziale
	E(1) = X(1);		%	esatto
	ermax = 0;
	
	s =1+c*h/(2*m);
	ss=1-c*h/(2*m);
	
	for n = 1 : N-1
		Dx= h*P(n+1)/m;
		T(n+1) = T(n) + h;	
  		X(n+1) = X(n) + Dx;
 		P(n+2)  = ( P(n+1)*ss - h*k*X(n+1) )/s; 
% 		E(n+1) = A * exp(-D*T(n+1)) * sin(w*T(n+1));		%	esatto
% %		valuta l'errore massimo
% 		scarto = abs(X(n+1)-E(n+1));
% 		if scarto > ermax    
% 			 ermax = scarto; 
% 		end
	end
	ermax=X(N) - A * exp(-D*T(N)) * sin(w*T(N));	
%	-------------------- fine ------------------	
	
