%	 moto armonico smorzato e forzato
%			xp(t) = R cos(wi t +b)
%			m DDx(t) + h Dx(t) + k x(t) = f0 sin(wi t)
%	----------modalita' grafica--------------
	close ; h1 = figure(1) ; 	
	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
%	set(h1, 'Units', 'normalized', 'Position', [0.5  0.5  0.5  0.5]) ; 
	hold on ; zoom on ; pause off
	whitebg('k')
% 	---------------------  Dati  ----------------------------
	M=4; 
	a=60*pi/180;
	T = 0 : 0.01 :10;
	k=5;		% rigidezza
	h=0.12;		% coefficiente resistenza
	m=0.1;		% massa
	eps=h/(2*m);	% costante di smorzamento
	w0= sqrt(k/m);	% pulsazione naturale
% 
 	wi=12; 	% pulsazione impressa:  
	b=1; 	% fase iniziale
	f0=60;	% forza 
	xs=f0/(m*w0^2); % elongazione statica 
	b = atan(-2*eps*wi/(w0^2-wi^2)); % fase del termine forzante 
	F = f0/m*1/((w0^2-wi^2)^2 +(2*eps*wi)^2); % fattore amplific. dinamico 
% ---------------------------------------------------------
%	OSSERVAZIONE: subplot(righe, colonne, numero del riquadro)
%	forza nulla     
	subplot(3,2,1) % quadro 1 (alto-sinistra)
	U = 0;
  	plot(T,U,'c')
	line([ 0  10],[0   0],'color','r');	% asse orizzontale
	axis([0  10   -6   6]);
	title('forza nulla','fontsize',18)
	pause
% -------------------
%	smorzato
	subplot(3,2,2)	% quadro 2 (alto-destra)
	X = M*exp(-eps*T).*sin(w0*T+a);
  	plot(T,X,'y')
	line([ 0  10],[0   0],'color','r');	% asse orizzontale
 	axis([0  10   -5   5]);
	hold on
	title('elongazione','fontsize',18)
	pause
% ---------------------------------------------------------
%	forza costante f0   
	subplot(3,2,3) % quadro 3 (medio-sinistra)
 	U = f0;
  	plot(T,U,'c')
	line([ 0  10],[0   0],'color','r'); % asse orizzontale
	axis([0  10   -100   100]);
	title('forza costante','fontsize',18)
	pause
% ----------- 
%	smorzato
	subplot(3,2,4)	% quadro 4 (medio-destra)
	X = M*exp(-eps*T).*sin(w0*T+a)+xs;
  	plot(T,X,'y')
	line([ 0  10],[0   0],'color','r');	% asse orizzontale
 	axis([0  10   -20   20]);
	hold on
	title('elongazione','fontsize',18)
	pause
% ---------------------------------------------------------
%	forza sinusoidale 
	subplot(3,2,5)	% quadro 5 (basso-sinistra)
 	f = f0*cos(wi*T);
  	plot(T,f,'c')
	line([ 0  10],[0   0],'color','r');	% asse orizzontale
	axis([0  10   -100   100]);
	title('forza sinusoidale','fontsize',18)
	pause
% -------------------
%	forzato
	subplot(3,2,6)	% quadro 6 (basso-destra)
	X = M*exp(-eps*T).*sin(w0*T+a)+xs*F*cos(wi*T+b);
  	plot(T,X,'y')
 	axis([0  10   -5   5]);
	line([ 0  10],[0   0],'color','r');	% asse orizzontale
	title('elongazione','fontsize',18)
% ---------------------------------------------------------

	
	
