%	-------------------------------------------------------------- 
%   		fattore di amplificazione dinamica
%							ampli2.m
%	-------------------------------------------------------------- 
%  In un programma MATLAB vi sono, al minimo due finestre: 
%  1) quella dei comandi (MATLAB Command Window)
%  2) quella di testo contenente il programma sorgente. 
%  Nella grafica si attivano una o piu' finestre grafiche.
%  
%  Azzera le variabili in memoria
     clear 	
%  Pulisci finestra dei comandi  (CLear Command Window)
	clc	 	
%	-------------------------------------------------------------- 
%				seleziona modalita' grafica 
%	-------------------------------------------------------------- 
% 	chiudi finestra grafica precedente	
	close		
% 	(in alternativa) chiudi tutte le finestre grafiche precedenti	
%   close all
% 	apre una finestra grafica di dimensioni volute: 
%  "figure" e' il comando che attiva la "finestra grafica"
%   h1 (sigla ad arbitrio) e' un identificatore del "manico" del comando "figure"
%  che servira' a specificare i parametri della finestra grafica con il comando successivo "set"
	h1 = figure; 	
% 	La posizione e le dimensioni della finestra grafica si precisano all'interno del comando "set"
%  Le unita' di misura possono essere: cm, mm, pixel, foot, ...
%  Poiche' risulta conveniente darle in proporzioni alle dimensioni dello schermo,
%  le cui dimensioni (larghezza, altezza) sono considerate unitarie,  
%  si usa il formato "normalized"  ovvero si scrive l'istruzione
 	set(h1, 'Units', 'normalized');
%  Nel caso si volesse esprimere le dimensioni in centimetri si dovrebbe usare la scrittura:
%  set(h1, 'Units', 'cm') 
%  Le dimensioni della finestra grafica si precisano dichiarando quattro numeri relativi a:
%  origine finestra in ascisse; 
%  origine finestra in ordinate;
%  lunghezza della finestra;
%  altezza della finestra.
%  Avendo scelto le unita' normalizzate questi quattro numeri vanno espressi come frazione dell'unita':
%  ad esempio volendo  posizionare la finestra grafica in basso a destra dello schermo
%  l'origine della finestra in ascissa dovra' essere la meta' della larghezza dello schermo: (0.5)
%  l'origine della finestra in ordinate risultera' zero: (0)
%  La lunghezza della finestra risultera' meta' della larghezza dello schermo: (0.5)
%  e la altezza della finestra risultera' meta' della altezza dello schermo: (0.5).
%  Questi quattro numeri devono essere messi come quattro componenti di un vettore
%  che, in MATLAB, si denota mettendo i numeri separati da virgole o solo da spazi entro una parentesi quadra:
%  [x-origine finestra, y-origine finestra,  lunghezza finestra, altezza finestra].
%  Il tutto viene messo nell'istruzione "set" nel modo seguente
 	set(h1, 'Position', [0.5  0.5  0.45  0.5]);
%  Se si volesse fare la figura a tutto schermo si dovrebbe scrivere
%	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]);
%   In questo caso e' conveniente dare come altezza non 1 ma 0.96 per lasciare fuori la striscia superiore
%  che contiene i comandi di MATLAB. Quindi
%	set(h1, 'Units', 'normalized', 'Position', [0  0  1  0.96]).
%
% 	COLORE DI SFONDO della finestra grafica. E' particolarmente piacevole avere lo sfondo nero
%  Questo si realizza con l'istruzione:
  	whitebg(h1, 'black')
%
%  TITOLO. Ogni finestra grafica e' bene che abbia nella parte superiore un titolo:
	h2=title('fattore di amplificazione dinamica');
%  Come sempre il "manico" h2 serve per specificare i parametri del titolo, quali il colore dei caratteri (fonts)
%  la loro dimensione (fontsize), il tipo di carattere (fontname), lo spessore del carattere (fontweight), 
%   le unita' di caratteri (fontunits) ecc.
	set(h2,'color','yellow' )              % gli otto colori predefiniti: 'w', 'r', 'y', 'g',  'c',  'b', 'm', 'k'
	set(h2,'fontsize',18) 		         % 8, 10, 12, 14, 18, 20, 24, ...
	set(h2,'fontname','helvetica')     % times, helvetica, courier, ...
	set(h2,'fontweight','light')      % bold, light, normal, demi
	set(h2,'fontunits','normalized')   % cm, pixel, points, inches,
%	Tutte queste assegnazioni si possono mettere in un'unica istruzione:
% 	set(h2,'color','yellow', 'fontsize',18,'fontname','helvetica','fontunits','normalized','fontweight','normal' ) 
%  Le informazioni sui fonts si trovano digitando "helpdesk" nella finestra dei comandi
%
% 	DIDASCALIE sugli assi
 	h3=xlabel('frequenza impressa / frequenza naturale');
  	set(h3,'color','yellow','fontsize',12)
  	h4=ylabel('fattore di amplificazione');
  	set(h4,'color','green','fontsize',12)
%  Si noti che i manici finora usati sono stati indicati con "h1", "h2", "h3", "h4" in quanto
%  il nome in inglese e' "handle": si sarebbe potuto usare qualsiasi altro identificatore ( per esempio: 
%  pippo).
%  Si noti anche che i  valori dei manici,  se manca il punto e virgola finale, vengono scritti
%  nella finestra dei comandi ogni volta che si manda il programma, 
%  cosa che non interessa e quindi da evitare.
%
%  ASSI CARTESIANI.    MATLAB sceglie automaticamente le dimensioni degli assi
%  in modo che il grafico vi stia dentro completamente.
%  In alternativa si possono fissare  gli assi di dimensioni volute. 
%  Ad esempio se si vuole che la ascissa vada da 0 a 3 e che la ordinata vada da 0 a 6 si scrivera'
%	axis([0 3 0 6] );
%  I quattro valori  "xmin" "xmax" "ymin"  "ymax" devono essere inseriti in un array: 
%   [xmin xmax ymin ymax]
%  TRACCIARE PIU' GRAFICI IN UNA STESSA FINESTRA
%	si deve usare l'istruzione "hold on" 
	hold on
%	-------------------------------------------------------------- 
%					traccia i grafici
%	-------------------------------------------------------------- 
%	Per creare il vettore delle ascisse bisogna assegnare un valore iniziale di X (in questo caso lo zero), 
%  un valore finale (3) ed il passo (0.01) con il quale intendo suddividere l'intervallo cosi' individuato.  
 	X=0:0.01:3;	
% 	"e" = costante di smorzamento/pulsazione naturale
%	notare che la variabile nel ciclo "for"  non e' 
%	necessariamnte intera
  for  e=0.1:0.1:1   
 		Y=1./sqrt((1-X.^2).^2+(2*e*X).^2);
		plot(X,Y,'cyan'); 
  end 
%	-------------------------------------------------------------- 
%					linee
%	-------------------------------------------------------------- 
	line([1  1],[0 6],'color', [1.00 0.62 0.40]);
	line([0  3],[1 1],'linewidth',0.5,'color','green');
%	--------------------------------------------------- 
%					scritte
%	-------------------------------------------------------------- 
 	text(1.1,5,'e=0.1','fontsize',18,'fontname','times','fontweight','light');
	text(1.25,2.5,'e=0.2','fontsize',18, 'fontname','times','fontweight','bold');
% 	text(1.25,3.5,'e=0.3','fontsize',18, 'fontname','times','fontweight','light');
% 	text(1.25,4.5,'e=0.4','fontsize',18, 'fontname','times','fontweight','demi');
% 	text(1.25,5.5,'e=0.4','fontsize',18, 'fontname','times','fontweight','normal');
%  	h3=title('fattore di amplificazione dinamica');
%  	set(h3,'fontsize',18,'color','white','fontname','times');
	pbprin1 = uicontrol('style','push','string','stampa',...
			'fontname','times','fontsize',12,...
			'horizontalalignment','center','Units','normalized',...
			'position',[0.01 0.01 0.08 0.05],'callback','print');

 
%	-------------------------------------------------------------- 

