% ---------------------------------------------------------------------
%  			OSCILLATORE SEMPLICE  
% ---------------------------------------------------------------------
%	Il programma mostra il moto oscillatorio smorzato 
% 	L'equazione differenziale e':
%		m DDx(t) + h Dx(t) + k x(t)= 0
% 	la soluzione generale e'
%   	x(t) = M exp(- e t) sin(w t + a) 
% 	essendo
%   	w = sqrt(w0^2-e^2) 
% 	assegnati i valori iniziali x0 e v0
%	w  sta per omega
%	w0 sta per omega0
%	a  sta per alpha    
%   e  sta per epsilon  
% ---------------------------------------------------------------------
	clear all   % cancella tutte le variabili in memoria  
 	close 	% chiudi tutte le finestre grafiche
	clc			% azzera la finestra dei comandi
% ---------------------------------------------------------------------
%	attiva la grafica
	h1=figure;
%	set(h1, 'Units', 'normalized', 'Position', [0  0  1  1]) ; 
	set(h1, 'Units', 'normalized', 'Position', [0.0  0.5  0.45  0.45]); 
	whitebg(h1,'black')
	hold on; grid on
	axis([0  1  -8  8])
	line([0  1],[0   0],'color','r','linewidth',1)
% ---------------------------------------------------------------------
%	parametri del sistema 
	k = 4000;	% rigidezza
	h = 0;	% coefficiente di smorzamento
 	m = 1;		% massa
%  
	w0 = sqrt(k/m); % pulsazione naturale del sistema
 	e  = h/(2*m);	% costante di smorzamento
% 	s  = fattore  
%		sub-critico (s < 1)
% 		critico (s = 1)
% 		sovra-critico (s > 1)
% 	s = 4;
% 	e = s*w0;		
% ---------------------------------------------------------------------
%  	condizioni iniziali   
  	x0 = 5;		% elongazione iniziale
	v0 = 20;    % velocit iniziale m/s
% ---------------------------------------------------------------------
	t = 0 : 0.001 : 1;	% array dei tempi
%
    if e > w0 		%  sistemi sovrasmorzati
		disp('smorzamento sovra-critico')
		mu=sqrt(e^2-w0^2);
		A=(mu*x0-e*x0 -v0)/(2*mu);
		B=(mu*x0+e*x0 +v0)/(2*mu);
        x = exp(-e*t).*(A*exp(-mu*t) +B*exp(mu*t));
     	plot(t,x,'linewidth',1,'color','c')
    end
%
	if e == w0 		%  smorzamento critico
		disp('smorzamento critico')
		A=x0;
		B=v0+e*x0;
        x = (A+B*t).*exp(-e*t);
    	plot(t,x,'linewidth',1,'color','m')
    end
%
    if e < w0  		%  sistema sottosmorzato
		disp('smorzamento sub-critico')
		w  = sqrt(w0^2-e^2); 	% pulsazione del moto smorzato  
		T  = 2*pi/w; 			% periodo del moto smorzato 
% 		trovare M ed alpha
		M = sqrt(x0^2+(v0+e*x0)^2/w^2);
% 		La funzione "asin" (arcsin) fornisce l'angolo tra -90 e 90: 
%		per avere l'angolo tra 90 e 270 occorre scrivere a=pigreco-a
		a = asin(x0/M); % fase iniziale
		if v0<0; a = pi-a; end
        x = M*exp(-e*t).*sin(w*t+a);
    	plot(t,x,'linewidth',1,'color','y')
    end
	

% ---------------------------------------------------------------------




